package com.emr.controller;

import com.emr.entity.Archive_Master_Vo;
import com.emr.entity.EmrHolidaySetVo;
import com.emr.entity.OffsetLimitPage;
import com.emr.service.ipml.HolidaySetService;
import com.emr.util.Msg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("holidaySet/")
public class HolidaySetController {
    @Autowired
    private HolidaySetService holidaySetService;
    @RequestMapping("holidaySetList")
    public String holidaySetList(){
        return "holidaySetDir/holidaySetList";
    }

    @ResponseBody
    @RequestMapping(value = "getHolidaySetList")
    public OffsetLimitPage getHolidaySetList(EmrHolidaySetVo holidaySetVo) {
        OffsetLimitPage result = holidaySetService.selectByColumn(holidaySetVo);
        return result;
    }

    @RequestMapping("save")
    @ResponseBody
    public Msg save(String startTime,String endTime,String checkBoxes,Integer flag){
        try{
            holidaySetService.update(startTime, endTime, checkBoxes, flag);
            return Msg.success();
        }catch (Exception e){
            e.printStackTrace();
            return Msg.fail("保存出错啦,请联系系统管理员");
        }
    }
}
