package com.emr.controller;

import com.emr.entity.Power_User;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.lang3.StringUtils;
import org.apache.cxf.endpoint.Client;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.UsernamePasswordToken;
import org.apache.shiro.subject.Subject;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletRequest;

/**
 * @author HJL
 * @create 2019/4/29
 */
@Controller
public class LoginController {

    @Value("${POWER_URLHEAD}")
    private String POWER_URLHEAD;

    @Value("${POWER_JSP}")
    private String POWER_JSP;

    @Value("${powerUrl}")
    private String powerUrl;

    @Value("${medicalRecordsRoomDeptId}")
    private String medicalRecordsRoomDeptId;

    @Value("${medicalepartmentDeptId}")
    private String medicalepartmentDeptId;

    @RequestMapping(value = "/toLogin")
    public String toLogin(Model model) {
        // 从session获取用户名
        // Subject currentUser = SecurityUtils.getSubject();
        // Session session = currentUser.getSession();
        //  session.removeAttribute("username");
        //  session.removeAttribute("menuList");
        //  session.removeAttribute("userSession");
        //session.invalidate();

        return "redirect:/login.jsp";
    }

    //实现用户登录@PathVariable("username")
    @RequestMapping(value = "/login")
    public String login(Model model, HttpServletRequest request) {
        try{
            String token = request.getParameter("token");
            if(StringUtils.isNoneBlank(token)){
                JAXDynamicClientFactory dcf = JAXDynamicClientFactory.newInstance();
                Client client = dcf.createClient(POWER_URLHEAD + "/WebService/PowerWebService?wsdl");
                Object[] objects = client.invoke("getInfosByUserId", token, "emr_medical_record");
                client.destroy();
                ObjectMapper mapper = new ObjectMapper();
                Power_User powerUser = mapper.readValue(objects[0].toString(), Power_User.class);
                //设置进session
                request.getSession().setAttribute("CURRENT_USER", powerUser);
                if (null == powerUser.getUserId()) {
                    return "redirect:/emr_medical_record/error.jsp";
                }
                String userName = request.getParameter("userName");
                String name = request.getParameter("name");
                UsernamePasswordToken userToken = new UsernamePasswordToken(userName, "123456");
                Subject subject = SecurityUtils.getSubject();
                subject.login(userToken);
                model.addAttribute("POWER_URLHEAD", POWER_JSP);
                request.getSession().setAttribute("token", token);
            }else{
                return "redirect:"+POWER_URLHEAD+"/login";
            }

        }catch (Exception e){
            e.printStackTrace();
        }
        model.addAttribute("isAllDeptIds",medicalRecordsRoomDeptId + "," + medicalepartmentDeptId);
        return "index";
    }

    @RequestMapping(value = "/index")
    public String Login() {
        return "index";
    }
}
 

