/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/19 14:39
 * Description:缺陷管理
 */
package com.emr.controller;

import com.alibaba.fastjson.JSON;
import com.emr.annotation.OptionalLog;
import com.emr.dao.Archive_MasterMapper;
import com.emr.entity.*;
import com.emr.service.*;
import com.emr.util.ExportExcelUtil;
import com.emr.util.ExportExcelUtil1;
import com.emr.vo.DeptStatistics;
import com.emr.vo.DoctorStatistics;
import com.emr.vo.V_CountVo;
import com.mchange.v2.collection.MapEntry;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;
import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@RequestMapping("vCount")
public class VCountController {
    @Autowired
    private V_CountService v_countService;

    @Autowired
    private Archive_MasterService archiveMasterService;

    @Autowired
    private Emr_DictionaryService emrDictionaryService;

    @Autowired
    private Archive_MasterMapper archiveMasterMapper;

    @RequestMapping(value = "/vCounts")
    public String faults(Model model){
        return "vCountDir/vCountList";
    }

    @ResponseBody
    @RequestMapping(value = "/vCountList")
    public OffsetLimitPage faultList(HttpServletRequest request, HttpServletResponse response, V_CountVo vCount, Integer offset, Integer limit) {
        OffsetLimitPage result = v_countService.selectPageByClo(vCount,offset, limit);
        return result;
    }

    @ResponseBody
    @RequestMapping(value = "/vCountNumList")
    public List<V_Count> medicalCountDayList(HttpServletResponse response, V_CountVo vCount) throws Exception {
        //统计列表
        return v_countService.selectByCol(vCount);
    }


    @ResponseBody
    @RequestMapping(value = "/exportExcel")
    public void exportExcel(HttpServletResponse response, V_CountVo vCount) throws Exception {
        String tableThNames = "科室代码,科室名称,出院人数,已归档,未归档,死亡人数,归档率(%),2日率(%),3日率(%),7日率(%)";
        String fieldCns = "deptCode,deptName,outNum,fileNum,unfileNum,deathNum,fileRate,day2Rate,day3Rate,day7Rate";
        //构造excel的数据
        List<V_Count> list = v_countService.selectByCol(vCount);
        if(null != list && !list.isEmpty()){
            for (int i = 0; i < list.size(); i++) {
                V_Count v_count = list.get(i);
                Double fileRate = Double.valueOf(v_count.getFileRate())*100;
                Double day2Rate = Double.valueOf(v_count.getDay2Rate())*100;
                Double day3Rate = Double.valueOf(v_count.getDay3Rate())*100;
                Double day7Rate = Double.valueOf(v_count.getDay7Rate())*100;
                v_count.setFileRate(fileRate.intValue()+"%");
                v_count.setDay2Rate(day2Rate.intValue()+"%");
                v_count.setDay2Rate(day3Rate.intValue()+"%");
                v_count.setDay7Rate(day7Rate.intValue()+"%");
            }
        }
//        for (int i = 0; i < list.size(); i++) {
//            if(list.get(i).getInNum()==null){
//                list.get(i).setInNum(0);
//            }
//            if (list.get(i).getOutNum() == null) {
//                list.get(i).setOutNum(0);
//            }
//            if (list.get(i).getFileNum() == null) {
//                list.get(i).setFileNum(0);
//            }
//            if (list.get(i).getUnfileNum() == null) {
//                list.get(i).setUnfileNum(0);
//            }
//            if (list.get(i).getDeathNum() == null) {
//                list.get(i).setDeathNum(0);
//            }
//            if (list.get(i).getFileRate() == null) {
//                list.get(i).setFileRate("0.0%");
//            }else{
//                Double val= Double.valueOf(list.get(i).getFileRate())/100;
//                list.get(i).setFileRate(val+"%");
//            }
//            if (list.get(i).getDay2Rate() == null) {
//                list.get(i).setDay2Rate("0.0%");
//            } else {
//                Double val = Double.valueOf(list.get(i).getDay2Rate()) / 100;
//                list.get(i).setDay2Rate(val + "%");
//            }
//            if (list.get(i).getDay3Rate() == null) {
//                list.get(i).setDay3Rate("0.0%");
//            } else {
//                Double val = Double.valueOf(list.get(i).getDay3Rate()) / 100;
//                list.get(i).setDay3Rate(val + "%");
//            }
//            if (list.get(i).getDay7Rate() == null) {
//                list.get(i).setDay7Rate("0.0%");
//            } else {
//                Double val = Double.valueOf(list.get(i).getDay7Rate()) / 100;
//                list.get(i).setDay7Rate(val + "%");
//            }
//        }

        //文件名
        String fileName = "统计数据" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil1 exportExcelUtil = new ExportExcelUtil1();
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }


    @ResponseBody
    @RequestMapping(value = "/exportExcel2")
    public void exportExcel(HttpServletResponse response, Archive_Master_Vo archiveMasterVo) throws Exception {
        String tableThNames = "名字,入院科室,入院日期,出院科室,出院日期,主管医生";
        String fieldCns = "name,deptAdmissionTo,admissionDateTime,deptName,dischargeDateTime,doctorInCharge";
        //构造excel的数据
        List<Archive_Master_Vo> list = archiveMasterService.selectByUnfile(archiveMasterVo);
        Emr_Dictionary dic = new Emr_Dictionary();
        dic.setEffective(1);
        dic.setTypecode("dept_code");
        //科室列表
        List<Emr_Dictionary> dicList = emrDictionaryService.dicByTypeCode(dic);

        for (int i = 0; i < list.size(); i++) {
            //替换科室
            for (int k = 0; k < dicList.size(); k++) {
                String deptName = list.get(i).getDeptName();
                //入院科室dept_admission_to
                String dept2 = list.get(i).getDeptAdmissionTo();

                if ((deptName != null && deptName.equals(dicList.get(k).getCode())) || (dept2 != null && dept2.equals(dicList.get(k).getCode()))) {
                    //出院科室
                    if(deptName != null) {
                        deptName = deptName.replace(deptName, dicList.get(k).getName());
                        list.get(i).setDeptName(deptName);
                    }
                    dept2 = dept2.replace(dept2, dicList.get(k).getName());
                    list.get(i).setDeptAdmissionTo(dept2);
                }
            }
        }

        //文件名
        String fileName = "未归档病历列表" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil exportExcelUtil = new ExportExcelUtil();
        response.setContentType("application/ms-excel;charset=gbk");
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }

    //获取完整信息
    @ResponseBody
    @RequestMapping(value = "/HomepageDic")
    public String HomepageDic(HttpServletRequest request, HttpServletResponse response) {
       String result="";
        try {
            String endpoint = "http://120.27.212.36:9999/filing/services/HomepageDictionary?wsdl";

            //String endpoint = "http://localhost:8080/ca3/services/caSynrochnized?wsdl";

            //直接引用远程的wsdl文件

            //以下都是套路
            Service service = new Service();
            Call call = (Call) service.createCall();
            call.setTargetEndpointAddress(endpoint);

            call.setOperationName(new QName("http://interfaces.ann.com/", "CheckData"));


            //call.setOperationName("CheckData");//WSDL里面描述的接口名称
            call.addParameter("masterId", org.apache.axis.encoding.XMLType.XSD_DATE, javax.xml.rpc.ParameterMode.IN);//接口的参数

            call.setReturnType(org.apache.axis.encoding.XMLType.XSD_STRING);//设置返回类型

            String temp = "02e4ba46662327995711";

             result = (String) call.invoke(new Object[]{temp});

            //给方法传递参数，并且调用方法

            System.out.println("result is " + result);

        } catch (Exception e) {

            System.err.println(e.toString());

        }
        return result;
    }

    //跳转医生统计页面
    @RequestMapping("/doctorFileList")
    public String doctorFileList(){
        return "vCountDir/doctorFileList";
    }

    //加载医生统计表格iframe
    @RequestMapping("/getDoctorFileInfoIframe")
    public String getDoctorFileInfoIframe(String deptCode,String doctor,String startTime,String endTime,Model model){
        //科室医师明细
        List<DoctorStatistics> list = archiveMasterMapper.getDoctorFileInfo(deptCode, doctor, startTime, endTime);
        //定义返回结果
        List<DeptStatistics> deptList = new ArrayList<>();
        if(null != list && !list.isEmpty()){
            //定义科室集合
            Map<String,String> deptMap = new LinkedHashMap<>();
            for (DoctorStatistics info:list) {
                deptMap.put(info.getDeptName(),info.getDeptName());
            }
            if(null != deptMap && !deptMap.isEmpty()){
                for(Map.Entry<String,String> dept:deptMap.entrySet()){
                    DeptStatistics deptStatistics = new DeptStatistics();
                    //设置科室总住院天数
                    int deptAdmissDay = 0;
                    //设置科室总逾期天数
                    int deptOverDays = 0;
                    //设置科室总份数
                    int deptCount = 0;
                    //设置科室总逾期份数
                    int deptOverCount = 0;
                    //定义科室结合
                    List<DoctorStatistics> deptDoctorList = new ArrayList<>();
                    //定义不重复医生集合
                    Map<String,String> doctorMap = new LinkedHashMap<>();
                    for (DoctorStatistics info:list) {
                        if(dept.getKey().equals(info.getDeptName())){
                            //统计住院总天数
                            deptAdmissDay += info.getAdmissDays();
                            //统计逾期天数
                            deptOverDays += info.getOverDays();
                            //统计总份数
                            deptCount++;
                            //统计总逾期份数
                            if(info.getOverDays() > 0){
                                deptOverCount++;
                            }
                            deptDoctorList.add(info);
                            doctorMap.put(info.getDoctor(),info.getDoctor());
                        }
                    }
                    //定义医生集合
                    List<DoctorStatistics> doctorList = new ArrayList<>();
                    //组织统计医生归档情况
                    if(null != deptDoctorList && !deptDoctorList.isEmpty()){
                        if(null != doctorMap && !doctorMap.isEmpty()){
                            for(Map.Entry<String,String> doctorKey:doctorMap.entrySet()){
                                DoctorStatistics doctorStatistics = new DoctorStatistics();
                                String deptName = "";
                                //设置总住院天数
                                int admissDay = 0;
                                //设置总逾期天数
                                int overDays = 0;
                                //设置总份数
                                int count = 0;
                                //设置总逾期份数
                                int overCount = 0;
                                for (DoctorStatistics info:list) {
                                    if (doctorKey.getKey().equals(info.getDoctor())) {
                                        deptName = info.getDeptName();
                                        //统计总天数
                                        admissDay += info.getAdmissDays();
                                        //统计逾期天数
                                        overDays += info.getOverDays();
                                        //统计总份数
                                        count++;
                                        //统计总逾期份数
                                        if(info.getOverDays() > 0){
                                            overCount++;
                                        }
                                    }
                                }
                                //设置科室名称
                                doctorStatistics.setDeptName(deptName);
                                //设置医生名称
                                doctorStatistics.setDoctor(doctorKey.getKey());
                                //设置总住院天数
                                doctorStatistics.setAdmissDays(admissDay);
                                //设置总逾期天数
                                doctorStatistics.setOverDays(overDays);
                                //设置总份数
                                doctorStatistics.setRecordCount(count);
                                //设置总逾期份数
                                doctorStatistics.setRecordOverCount(overCount);
                                doctorList.add(doctorStatistics);
                            }
                        }
                    }
                    //设置科室名
                    deptStatistics.setDeptName(dept.getKey());
                    //设置科室总住院天数
                    deptStatistics.setDeptAdmissDay(deptAdmissDay);
                    //设置科室总逾期天数
                    deptStatistics.setDeptOverDays(deptOverDays);
                    //设置科室总份数
                    deptStatistics.setDeptCount(deptCount);
                    //设置科室总逾期份数
                    deptStatistics.setDeptOverCount(deptOverCount);
                    //设置医生集合
                    deptStatistics.setDoctorData(doctorList);
                    deptList.add(deptStatistics);
                }
            }
        }
        model.addAttribute("deptList",deptList);
        return "vCountDir/doctorFileListIframe";
    }
}
 

