/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/19 14:38
 * Description:出院浏览
 */
package com.emr.controller;

import com.alibaba.fastjson.JSON;
import com.emr.dao.ArchiveSumbitdateInfoMapper;
import com.emr.dao.Archive_DetailMapper;
import com.emr.dao.EmrPatientMapper;
import com.emr.entity.*;
import com.emr.service.Archive_MasterService;
import com.emr.service.Emr_Fault_DetailService;
import com.emr.util.ExceptionPrintUtil;
import com.emr.util.ExportExcelUtil;
import com.emr.util.Msg;
import com.emr.util.OracleConnect;
import com.emr.vo.HisCollectInfo;
import org.apache.commons.lang3.StringUtils;
import org.apache.cxf.endpoint.Client;
import org.apache.log4j.Logger;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.session.Session;
import org.apache.shiro.subject.Subject;
import org.apache.shiro.util.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

@Controller
@RequestMapping("/beHosp")
public class beHospitaledController {
    private static Logger log = Logger.getLogger("myLog");
    @Autowired
    private Archive_MasterService archiveMasterService;

    @Autowired
    private Emr_Fault_DetailService emrFaultDetailService;

    @Autowired
    private EmrPatientMapper patientMapper;

    @Autowired
    private ArchiveSumbitdateInfoMapper sumbitdateInfoMapper;
    @Value("${HomepageDictionary}")
    private String HomepageDictionary;
    @Value("${HomepageMethod}")
    private String HomepageMethod;
    @Autowired
    private Archive_DetailMapper detailMapper;
    @RequestMapping(value = "/beHosps")
    public String inHospitals(){
        return "beHospitaledDir/beHospList";
    }
    @ResponseBody
    @RequestMapping(value = "/beHospList")
    public OffsetLimitPage beHospList(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit,Integer isSearch) {
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        OffsetLimitPage result = archiveMasterService.selectByColumn(archiveMasterVo, offset, limit);
        return result;
    }


    @ResponseBody
    @RequestMapping(value = "/exportExcel")
    public void exportExcel(HttpServletResponse response, Archive_Master_Vo archiveMasterVo,Integer isSearch) throws Exception {
        String tableThNames = "住院号,住院次数,名字,性别,身份证,出院科室,出院日期,主管医生,状态";
        String fieldCns = "inpNo,visitId,name,sex,idNo,deptName,dischargeDateTime,doctorInCharge,archivestate";
        //构造excel的数据
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        List<Archive_Master_Vo> list = archiveMasterService.selectByColumn(archiveMasterVo);

        //文件名
        String fileName = "出院浏览" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil exportExcelUtil = new ExportExcelUtil();
        response.setContentType("application/ms-excel;charset=gbk");
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }

    @ResponseBody
    @RequestMapping(value = "/updateStateByArchivId")
    public String updateStateByArchivId(Emr_Fault_Detail emrFaultDetail) {
        String result = "";
        result = checkSuccessMethod(emrFaultDetail.getArchiveDetailId());
        // 从session获取用户名
        Subject currentUser = SecurityUtils.getSubject();
        Session session = currentUser.getSession();
        String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String nowTime = format1.format(new Date());
        if(result.equals("完整")) {
            //修改病案归档状态
            Archive_Master archiveMaster = new Archive_Master();
            archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
            archiveMaster.setArchivestate(emrFaultDetail.getState());
            //设置审核时间
            archiveMaster.setCheckDatetime(format1.format(new Date()));
            //设置审核人
            archiveMaster.setCheckDoctor(username);
            archiveMaster.setLockinfo(result);
            int bol = archiveMasterService.updateByClo(archiveMaster);
            //添加初审内容
            if (bol == 1) {
                //参数输入
                emrFaultDetail.setCreater(username);
                emrFaultDetail.setCreateTime(nowTime);
                emrFaultDetail.setState("未召回");
                bol = emrFaultDetailService.insertSel(emrFaultDetail);
            }
        }else{
            //修改病案归档完整内容Lockinfo
            Archive_Master archiveMaster = new Archive_Master();
            archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
            //设置审核时间
            archiveMaster.setCheckDatetime(nowTime);
            //设置审核人
            archiveMaster.setCheckDoctor(username);
            archiveMaster.setLockinfo(result);
            archiveMasterService.updateByClo(archiveMaster);
        }
        return result;
    }

    //校验完整性
    @ResponseBody
    @RequestMapping(value = "/checkSuccess")
    public String checkSuccess(String archiveDetailId) {
        return checkSuccessMethod(archiveDetailId);
    }

    //校验完整性方法
    private String checkSuccessMethod(String archiveDetailId){
        String result = "";
        try {
            String endpoint = HomepageDictionary;
            //String endpoint = "http://localhost:8080/ca3/services/caSynrochnized?wsdl";
            String method = HomepageMethod;
            JAXDynamicClientFactory factory = JAXDynamicClientFactory.newInstance();
            Client client = factory.createClient(endpoint);
            Object[] res = null;
            res = client.invoke(method, archiveDetailId);
            client.destroy();
            result = (String) res[0];
        } catch (Exception e) {
            System.err.println(e.toString());
        }
        return result;
    }

    @ResponseBody
    @RequestMapping(value = "/forceWZ")
    public String forceWZ(HttpServletRequest request, HttpServletResponse response, Emr_Fault_Detail emrFaultDetail) {
            //修改病案归档状态
            Archive_Master archiveMaster = new Archive_Master();
            archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
            archiveMaster.setArchivestate("初审");
            archiveMaster.setLockinfo(emrFaultDetail.getContent());
            int bol = archiveMasterService.updateByClo(archiveMaster);

            // 从session获取用户名
            Subject currentUser = SecurityUtils.getSubject();
            Session session = currentUser.getSession();
            String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

            SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String nowTime = format1.format(new Date());

            //参数输入
            emrFaultDetail.setCreater(username);
            emrFaultDetail.setCreateTime(nowTime);
            emrFaultDetail.setState("未召回");
            bol = emrFaultDetailService.insertSel(emrFaultDetail);

        return "1";
    }

    //出院初审先查询his是否医生护士全部提交
    @RequestMapping("getInfoFromHis")
    @ResponseBody
    //@DataSource(dataSource = "dataSource1")
    public int getInfoFromHis(String patientId) throws Exception{
        try {
            String sql = "select fpatno from pacs.v_emrpatient where fpatno = '"+patientId+"'";
            String str = OracleConnect.select(sql);
            if(StringUtils.isNoneBlank(str)){
                return 1;
            }else{
                return 0;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }

    /**
     * 查询pdf生成完成情况
     * @param collectInfo
     * @return
     */
    @RequestMapping(value="getPdfCollectInfoFromHis",method = RequestMethod.POST)
    @ResponseBody
    public String getPdfCollectInfoFromHis(HisCollectInfo collectInfo){
        try {
            String sql = getSelectSqlForGetPdfCollect(collectInfo);
            List<HisCollectInfo> list = new ArrayList<>();
            /*for (int i = 1; i <= 11; i++) {
                HisCollectInfo obj1 = new HisCollectInfo();
                obj1.setFrecName("标题" + i);
                obj1.setFentryNo((800+i)+"");
                obj1.setFentryName("分类"+(800+i));
                if(i>=2){
                    obj1.setPdfflag("1");
                    obj1.setFfileId((4234+i)+"");
                }else{
                    obj1.setPdfflag("0");
                }
                list.add(obj1);
            }*/
            log.info("优先采集查询语句:"+sql);
            try {
                //查询oracle
                list = OracleConnect.select1(sql);
            }catch (Exception e){
                ExceptionPrintUtil.printException(e);
                log.info("优先采集查询oracle出错,请查看error.log文件");
            }
            log.info("list数量:"+list.size()+"个->list:"+list);
            //赋值两时间：最近上传时间与最新手动提交时间
            if(!CollectionUtils.isEmpty(list)) {
                //判断是否带标题或编号
                list = selectListTemp(collectInfo,list);
                if(!CollectionUtils.isEmpty(list)) {
                    setTwoTimeForList(list);
                }
            }
            log.info("优先采集查询成功!");
            return JSON.toJSONString(list);
        } catch (Exception e) {
            ExceptionPrintUtil.printException(e);
        }
        return null;
    }
    //判断是否带标题或编号
    private List<HisCollectInfo> selectListTemp(HisCollectInfo collectInfo, List<HisCollectInfo> list) {
        //定义临时变量
        int flag = 0;
        //标题
        String frecName = collectInfo.getFrecName();
        if(StringUtils.isNotBlank(frecName)){
            flag = 1;
        }
        //分类编码
        String fentryNo = collectInfo.getFentryNo();
        if(StringUtils.isNotBlank(fentryNo)){
            flag = 2;
        }
        if(StringUtils.isNotBlank(frecName) && StringUtils.isNotBlank(fentryNo)){
            flag = 3;
        }
        if(flag != 0){
            List<HisCollectInfo> tempList = new LinkedList<>();
            for(HisCollectInfo info : list){
                if(flag == 1){
                    if(info.getFrecName().contains(frecName)){
                        tempList.add(info);
                    }
                }else if(flag == 2){
                    if(info.getFentryNo().contains(fentryNo)){
                        tempList.add(info);
                    }
                }else {
                    if(info.getFrecName().contains(frecName) && info.getFentryNo().contains(fentryNo)){
                        tempList.add(info);
                    }
                }
            }
            return tempList;
        }else{
            return list;
        }
    }

    //赋值两时间：最近上传时间与最新手动提交时间
    private void setTwoTimeForList(List<HisCollectInfo> list) {
        StringBuilder fileIdsStr = new StringBuilder();
        for (HisCollectInfo hisCollectInfo1 : list) {
            String ffileId = hisCollectInfo1.getFfileId();
            if (StringUtils.isNotBlank(ffileId)) {
                if (StringUtils.isNotBlank(fileIdsStr)) {
                    fileIdsStr.append(",");
                }
                fileIdsStr.append("'").append(ffileId).append("'");
            }
        }
        //查询detail表的上传时间
        List<Archive_Detail> archiveDetails = detailMapper.selectUpdateTimeBySubAssort(fileIdsStr.toString());
        //查询archive_sumbitDate_info的提交时间
        List<ArchiveSumbitdateInfo> archiveSumbitdateInfoList = sumbitdateInfoMapper.selectOneByPatientId(list.get(0).getFpatno(),null,null);
        if(!CollectionUtils.isEmpty(archiveDetails) || !CollectionUtils.isEmpty(archiveSumbitdateInfoList)){
            for (HisCollectInfo hisCollectInfo : list) {
                String ffileId = hisCollectInfo.getFfileId();
                //分类编号
                String fentryNo = hisCollectInfo.getFentryNo();
                if (!CollectionUtils.isEmpty(archiveDetails) && StringUtils.isNotBlank(ffileId)) {
                    for (Archive_Detail archiveDetail : archiveDetails) {
                        if (ffileId.equals(archiveDetail.getSubassort())) {
                            hisCollectInfo.setUpdateLoadTime(archiveDetail.getUploaddatetime());
                            break;
                        }
                    }
                }
                if (!CollectionUtils.isEmpty(archiveSumbitdateInfoList)) {
                    for (ArchiveSumbitdateInfo info : archiveSumbitdateInfoList) {
                        String fentryNoTemp = info.getFentryNo();
                        if(StringUtils.isNotBlank(fentryNo) && StringUtils.isNotBlank(fentryNoTemp) && fentryNo.equals(fentryNoTemp)){
                            if (StringUtils.isNotBlank(ffileId) && StringUtils.isNotBlank(ffileId) && ffileId.equals(info.getFileId())) {
                                hisCollectInfo.setSumbitTime(info.getCreateTime());
                                break;
                            }else{
                                //取分类的最后一个
                                hisCollectInfo.setSumbitTime(info.getCreateTime());
                            }
                        }
                    }
                }
            }
        }
    }

    //组织sql语句查询orcle查询文件完成情况
    private String getSelectSqlForGetPdfCollect(HisCollectInfo collectInfo){
        String sql = "select FPATNO,FENTRY_NO,FENTRY_NAME,FREC_NAME,FFILE_ID,PDF_FLAG from pacs.v_emrpdf_rec where fpatno = '"+collectInfo.getFpatno()+"'";
        //状态
        String pdfflag = collectInfo.getPdfflag();
        if(StringUtils.isNotBlank(pdfflag)){
            sql += " and pdf_flag = '"+pdfflag+"'";
        }
        return sql;
    }


    /**
     * 优先采集操作
     * @param fpatno
     * @param fentryNos
     * @param ffileIds
     * @return
     */
    @RequestMapping(value="insetHisPdfCollect",method = RequestMethod.POST)
    @ResponseBody
    public Msg insetHisPdfCollect(String fpatno,String fentryNos,String ffileIds){
        SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //现在时间
        String fapplytime = fmt.format(new Date());
        if(StringUtils.isBlank(fentryNos)){
            return Msg.fail("分类编号不能为空");
        }
        String[] fentryNoList = fentryNos.split(",");
        String[] ffileIdList = ffileIds.split(",");
        for (int i = 0; i < fentryNoList.length; i++) {
            if(StringUtils.isNotBlank(fentryNoList[i])){
                String fileId = null;
                if(StringUtils.isNotBlank(ffileIdList[i]) && !"undefined".equals(ffileIdList[i])){
                    fileId = "'" + ffileIdList[i] + "'";
                }
                String sql = "insert into pacs.p_pdf_print(FENTRYNO,FPATNO,FAPPLYTIME,FFILE_ID) values('"+fentryNoList[i]+"','"+fpatno+"','"+fapplytime+"',"+fileId+")";
                log.info("优先采集插入语句:"+sql);
                try {
                    OracleConnect.insert(sql);
                    log.info("优先采集插入oracle成功");
                }catch (Exception e){
                    log.info("优先采集插入oracle失败,请查看error.log文件");
                    ExceptionPrintUtil.printException(e);
                }
                if (insertSubmitDateInfo(fpatno,fapplytime,fentryNoList[i], ffileIdList[i])){
                    return Msg.fail("服务器内部出错,请联系系统管理员!");
                }
            }
        }
        return Msg.success();
    }

    private boolean insertSubmitDateInfo(String fpatno, String fapplytime, String fentryNo,String fileId) {
        //插入记录
        ArchiveSumbitdateInfo info = new ArchiveSumbitdateInfo();
        info.setPatientId(fpatno);
        info.setFentryNo(fentryNo);
        if(StringUtils.isBlank(fileId) || "undefined".equals(fileId)) {
            fileId = null;
        }
        info.setFileId(fileId);
        //查询时候存在，存在更新，不存在添加
        try {
            List<ArchiveSumbitdateInfo> archiveSumbitdateInfoList = sumbitdateInfoMapper.selectOneByPatientId(fpatno,fentryNo,fileId);
            info.setCreateTime(fapplytime);
            if(!CollectionUtils.isEmpty(archiveSumbitdateInfoList)){
                ArchiveSumbitdateInfo archiveSumbitdateInfo = archiveSumbitdateInfoList.get(0);
                archiveSumbitdateInfo.setCreateTime(fapplytime);
                sumbitdateInfoMapper.updateByPrimaryKeySelective(archiveSumbitdateInfo);
            }else{
                sumbitdateInfoMapper.insertSelective(info);
            }
            log.info("优先采集插入本地数据库成功");
        }catch (Exception e){
            ExceptionPrintUtil.printException(e);
            log.error("优先采集插入本地数据库失败,请查看error.log文件");
            return true;
        }
        return false;
    }
}
 

