/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/19 14:39
 * Description:缺陷管理
 */
package com.emr.controller;

import com.emr.entity.*;
import com.emr.service.Emr_DictionaryService;
import com.emr.service.Emr_Fault_DetailService;
import com.emr.service.Emr_Fault_TypeService;
import com.emr.util.ExportExcelUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Controller
@RequestMapping("fault")
public class faultController {
    @Autowired
    private Emr_Fault_DetailService emrFaultDetailService;

    @Autowired
    private Emr_Fault_TypeService emrFaultTypeService;

    @Autowired
    private Emr_DictionaryService emrDictionaryService;

    @RequestMapping(value = "/faults")
    public String faults(Model model){
        return "faultDir/faultList";
    }

    @ResponseBody
    @RequestMapping(value = "/faultList")
    public OffsetLimitPage faultList(Integer isSearch, Emr_Fault_Vo emrFaultVo, Integer offset, Integer limit) {
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            emrFaultVo.setStartDate(null);
            emrFaultVo.setEndDate(null);
        }
        OffsetLimitPage result = emrFaultDetailService.selectByCol(emrFaultVo,offset, limit);
        return result;
    }


    @ResponseBody
    @RequestMapping(value = "/exportExcel")
    public void exportExcel(HttpServletResponse response, Emr_Fault_Vo emrFaultVo,Integer isSearch) throws Exception {
        String tableThNames = "住院号,住院次数,姓名,出院科室,出院日期,归档状态,评分,回退内容,缺陷选项,缺陷内容,创建时间";
        String fieldCns = "inpNo,visitId,name,deptName,dischargeDateTime,archivestate,score,backContent,assortId,content,createTime";
        //构造excel的数据
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            emrFaultVo.setStartDate(null);
            emrFaultVo.setEndDate(null);
        }
        List<Emr_Fault_Vo> list = emrFaultDetailService.selectByCol(emrFaultVo);
        Emr_Dictionary dic = new Emr_Dictionary();
        dic.setEffective(1);
        dic.setTypecode("dept_code");
        //科室列表
        List<Emr_Dictionary> dicList = emrDictionaryService.dicByTypeCode(dic);
        //获取缺陷类别列表
        Emr_Fault_Type obj=new Emr_Fault_Type();
        obj.setEffective(1);
        //缺陷选项
        List<Emr_Fault_Type>  typeLis= emrFaultTypeService.selectByCol(obj);
        for(int i=0;i<list.size();i++){
            String assortId = list.get(i).getAssortId();
            if (!"".equals(assortId) && assortId != null) {
                String[] assorArr = assortId.split(",");
                //替换类别
                for (int j = 0; j < typeLis.size(); j++) {
                    String id = String.valueOf(typeLis.get(j).getId());
                    if (Arrays.asList(assorArr).contains(id)) {
                        assortId = assortId.replace(id, typeLis.get(j).getTypeName());
                        list.get(i).setAssortId(assortId);
                    }
                }
            }

            //替换科室
            for (int k = 0; k < dicList.size(); k++) {
                String deptName = list.get(i).getDeptName();
                //入院科室dept_admission_to
                String dept2 =  list.get(i).getDeptAdmissionTo();;
                if ((deptName != null && deptName.equals(dicList.get(k).getCode()))|| (dept2 != null && dept2.equals(dicList.get(k).getCode()))) {
                    //出院科室
                    deptName = deptName.replace(deptName, dicList.get(k).getName());
                    list.get(i).setDeptName(deptName);

                    dept2 = dept2.replace(dept2, dicList.get(k).getName());
                    list.get(i).setDeptAdmissionTo(dept2);
                }
            }
        }


        //文件名
        String fileName = "缺陷信息数据" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil exportExcelUtil = new ExportExcelUtil();
        response.setContentType("application/ms-excel;charset=gbk");
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }


//    @ResponseBody
//    @RequestMapping(value = "/faultByArchiveId")
//    public Emr_Fault_Detail faultByArchiveId(HttpServletRequest request, HttpServletResponse response, String archiveDetailId) {
//        Emr_Fault_Detail result = emrFaultDetailService.selectByArchiveDetailId(archiveDetailId);
//        return result;
//    }
}
 

