/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/19 14:39
 * Description:在院浏览
 */
package com.emr.controller;

import com.emr.entity.*;
import com.emr.service.Archive_DetailService;
import com.emr.service.Archive_MasterService;
import com.emr.service.Emr_DictionaryService;
import com.emr.service.Emr_PictureService;
import com.emr.util.ExportExcelUtil;
import com.emr.util.Jpg2PdfUtil;
import com.emr.util.PrintToPdfUtil;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.session.Session;
import org.apache.shiro.subject.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


@Controller
@RequestMapping("/inHosp")
public class inHospitalController {
    //private Logger logger = Logger.getLogger(inHospitalController.class);
    @Value("${pdfWater}")
    private String pdfWater;
    @Autowired
    private Archive_MasterService archiveMasterService;

    @Autowired
    private Emr_DictionaryService emrDictionaryService;

    @Autowired
    private Archive_DetailService archiveDetailService;

    @Autowired
    private Emr_PictureService emrPictureService;

    @Value("${pictureUrl}")
    private String pictureUrl;

    @RequestMapping(value = "/inHospitals")
    public String inHospitals(Model model) {
        return "inHospitalDir/inHositalList";
    }

    @ResponseBody
    @RequestMapping(value = "/inHospitalList")
    public OffsetLimitPage inHospitalList(Integer isSearch, Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit) {
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        OffsetLimitPage result = archiveMasterService.selectByCol(archiveMasterVo, offset, limit);
        return result;
    }

    @ResponseBody
    @RequestMapping(value = "/exportExcel")
    public void exportExcel(HttpServletResponse response, Archive_Master_Vo archiveMasterVo,Integer isSearch) throws Exception {
        String tableThNames = "住院号,住院次数,名字,性别,身份证,当前科室,入院日期,主管医生,状态";
        String fieldCns = "inpNo,visitId,name,sex,idNo,deptName,admissionDateTime,doctorInCharge,archivestate";
        //构造excel的数据
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        List<Archive_Master_Vo> list = archiveMasterService.selectByCol(archiveMasterVo);
        //文件名
        String fileName = "在院浏览" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil exportExcelUtil = new ExportExcelUtil();
        response.setContentType("application/ms-excel;charset=gbk");
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }

    @ResponseBody
    @RequestMapping(value = "/getDept")
    public List<Emr_Dictionary> getDept(HttpServletResponse response, Emr_Dictionary emrDictionary) throws Exception {
        emrDictionary.setEffective(1);
        emrDictionary.setTypecode("dept_code");
        List<Emr_Dictionary> emr_dictionaries = emrDictionaryService.dicByTypeCode(emrDictionary);
        //科室列表
        return emr_dictionaries;
    }

    @ResponseBody
    @RequestMapping(value = "/getAssort")
    public List<Archive_Detail_Vo> getDept(HttpServletResponse response, Archive_Detail_Vo archiveDetailVo) throws Exception {
        //分段列表
        return archiveDetailService.selectByClo(archiveDetailVo);
    }

    @ResponseBody
    @RequestMapping(value = "/getAssortdetail")
    public OffsetLimitPage getAssortdetail(HttpServletResponse response, Archive_Detail_Vo archiveDetailVo, Integer offset, Integer limit) throws Exception {
        //分段详情列表分页
        OffsetLimitPage result = archiveDetailService.detailByClo(archiveDetailVo, offset, limit);
        return result;
    }

    @ResponseBody
    @RequestMapping(value = "/updateState")
    public int updateState(HttpServletRequest request,HttpServletResponse response, Archive_Detail archiveDetail) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        archiveDetail.setFlag("1");
        //修改状态分段信息
        return archiveDetailService.updateCloById(archiveDetail);
    }

    @ResponseBody
    @RequestMapping(value = "/updateStateAll")
    public int updateStateAll(HttpServletRequest request,HttpServletResponse response, Archive_Detail archiveDetail) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        int bol=0;
        String idStr=archiveDetail.getId();
        if(idStr.length()>0){
            String[] idArr = idStr.split(",");
            //archiveDetail.setFlag("1");
            for(int i=0;i<idArr.length;i++){
                archiveDetail.setId(idArr[i]);
                //修改状态分段信息
                bol=archiveDetailService.updateCloById(archiveDetail);
            }
        }
        return bol;
    }

    @ResponseBody
    @RequestMapping(value = "/saveInfo")
    public String saveInfo(HttpServletRequest request,HttpServletResponse response, Archive_Detail archiveDetail) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        String result="";
        //判断id是否为空
        if(archiveDetail.getId()==null || archiveDetail.getId()==""){
            //生成id
            //插入记录
            int bol= archiveDetailService.insertSel(archiveDetail);
            if(1==bol){
                result="添加成功！";
            }else{
                result = "添加失败！";
            }

        }else{
            //根据id查找是否存在记录
            Archive_Detail entity= archiveDetailService.selectByid(archiveDetail.getId());
            if(entity!=null){
                //修改记录
                int bol = archiveDetailService.updateCloById(archiveDetail);
                if (1 == bol) {
                    result = "修改成功！";
                } else {
                    result = "修改失败！";
                }
            } else {
                result = "该记录不存在！";
            }
        }

        return result;
    }

    /**
     * 根据病案号或类别或图片id获取图片列表，并生成PDF并返回pdf文件名
     *
     * @param response
     * @param request
     * @param imgStr
     * @param masterId
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/getPdfToPdf/{masterId}/{imgStr}")
    public void getPdfToPdf(HttpServletResponse response, HttpServletRequest request, @PathVariable("imgStr") String imgStr, @PathVariable("masterId") String masterId) throws Exception {
        //病案号文件夹
        if (masterId != "" && masterId != null) {
            //生成pdf(图片路径，pdf生成路径，图片路径文件夹列表)
            List imgList = new ArrayList();
            if (imgStr != "" && imgStr != null) {
                String[] imgArr = imgStr.split(",");
                if (imgArr.length > 0) {
                    for (int i = 0; i < imgArr.length; i++) {
                        imgList.add(imgArr[i]);
                    }
                }
            }
            //获取废除的pdf文件名列表archive_detail
            List pdfList = new ArrayList();
            Archive_Detail archiveDetail = new Archive_Detail();
            archiveDetail.setFlag("0");
            archiveDetail.setMasterid(masterId.trim());
            archiveDetail.setTitle(imgStr);
            List<Archive_Detail> arList = archiveDetailService.selectByCol(archiveDetail);
            if (arList != null) {
                for (int m = 0; m < arList.size(); m++) {
                    String str = arList.get(m).getPdfPath();
                    if(StringUtils.isNoneBlank(str)){
                        pdfList.add(str);
                    }
                }
            }
            Jpg2PdfUtil.mulFile2One(response,pdfList,pdfWater);
        }
    }
/*
    @ResponseBody
    @RequestMapping(value = "/getPdfToPdf")
    public String getPdfToPdf(HttpServletResponse response, HttpServletRequest request, String imgStr, String masterId) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        String result = "";
        // 项目在容器中实际发布运行的根路径
        String realPath = request.getSession().getServletContext().getRealPath("/");
        realPath = realPath.split("target")[0] + pictureUrl+"\\static\\img\\";
        //pdf名称
        String pdfFileName = String.valueOf(System.currentTimeMillis());

        //病案号文件夹
        if (masterId != "" && masterId != null) {
            //判断文件夹是否存在
            File fileDic = new File(realPath + masterId + "\\");
            if (!fileDic.exists() && !fileDic.isDirectory()) {
                fileDic.mkdirs();
            }


            //病案号/类别/id文件夹(图片路径下的子文件夹名称)
            //生成pdf(图片路径，pdf生成路径，图片路径文件夹列表)
            List imgList = new ArrayList();
            if (imgStr != "" && imgStr != null) {
                String[] imgArr = imgStr.split(",");
                if (imgArr.length > 0) {
                    for (int i = 0; i < imgArr.length; i++) {
                        imgList.add(imgArr[i]);
                    }
                }
            }

//            if(imgList.size()==1){
//                result= masterId.trim() + "/"+ imgList.get(0) +"/"+ imgList.get(0)+".pdf";
//            }else{
                String pdfPath = realPath+"pdfFiles\\" + "typesPdf\\"+ pdfFileName + ".pdf";
                String imgPath= realPath + "pdfFiles\\"+masterId.trim()+"\\";
                //获取废除的pdf文件名列表archive_detail
                List pdfList=new ArrayList();
                Archive_Detail archiveDetail = new Archive_Detail();
                archiveDetail.setFlag("0");
                archiveDetail.setMasterid(masterId.trim());
                archiveDetail.setTitle(imgStr);
                List<Archive_Detail> arList=archiveDetailService.selectByCol(archiveDetail);
                if(arList!=null) {
                    for (int m = 0; m < arList.size(); m++) {
                        String str = arList.get(m).getPdfPath();
                        if (str.indexOf("..\\static\\img\\pdfFiles\\") != -1) {
                            str = str.split("pdfFiles")[1];
                            str = realPath + "pdfFiles" + str;
                        }
                        // str= str.substring(str.lastIndexOf("\\") + 1);
                        pdfList.add(str);
                    }
                }

                //PrintToPdfUtil.pdtToPdf(imgPath,pdfPath, imgList,pdfList);
                PDFUtils.getPdf(pdfPath, pdfList);
                result = "typesPdf/"+pdfFileName + ".pdf";
//            }
        } else {
            result = "a000000.pdf";
        }
        return result;
    }
*/

    /**
     * 根据病案号或类别或图片id获取图片列表，并生成PDF并返回pdf文件名
     * @param response
     * @param request
     * @param imgStr
     * @param masterId
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/getPdf")
    public String getPdf(HttpServletResponse response, HttpServletRequest request,String imgStr, String masterId) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        String result="";
        // 项目在容器中实际发布运行的根路径
        String realPath = request.getSession().getServletContext().getRealPath("/");
        realPath = realPath.split("target")[0] + pictureUrl+"\\static\\img\\uploads\\";
        //pdf名称
        String pdfFile = String.valueOf(System.currentTimeMillis());
        String pdfPath = realPath + "pdfFiles\\" + pdfFile + ".pdf";
        //病案号文件夹
        if(masterId!="" && masterId!=null ){
            realPath = realPath+ masterId+"\\";
            //判断文件夹是否存在
            File fileDic = new File(realPath );
            if (!fileDic.exists() && !fileDic.isDirectory()) {
                fileDic.mkdirs();
            }


            //病案号/类别/id文件夹(图片路径下的子文件夹名称)
            //生成pdf(图片路径，pdf生成路径，图片路径文件夹列表)
            List imgList=new ArrayList();
            if(imgStr!="" && imgStr!=null) {
                String[] imgArr = imgStr.split(",");
                if (imgArr.length > 0) {
                    for (int i = 0; i < imgArr.length; i++) {
                        imgList.add(imgArr[i]);
                    }
                }
            }
            //imgList.add(imgStr.split())imgStr.split(","));
            PrintToPdfUtil.toPdf(realPath, pdfPath, imgList);
            result= pdfFile + ".pdf";
        }else{
            result="a000000.pdf";
        }
        return result;
    }

    /**
     * 根据病案号或类别或图片id获取图片列表，并生成PDF并返回pdf文件名
     *
     * @param response
     * @param request
     * @param idStr     *
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/getPdfById/{idStr}")
    public void getPdfById(HttpServletResponse response, HttpServletRequest request, @PathVariable("idStr") String idStr) throws Exception {
        Archive_Detail detail=new Archive_Detail();
        StringBuilder idStringBuild = new StringBuilder();
        if(StringUtils.isNotBlank(idStr)){
            String[] idArr = idStr.split(",");
            //加引号
            for(String id: idArr){
                if(StringUtils.isNotBlank(idStringBuild)){
                    idStringBuild.append(",");
                }
                idStringBuild.append("'").append(id).append("'");
            }
            detail.setTitle(idStringBuild.toString());
            //根据所有id获取PDF列表
            List<Archive_Detail> arList = archiveDetailService.selectByIdStr(detail);
            //获取废除的pdf文件名列表archive_detail
            List pdfList = new ArrayList();
            //将所有记录的pdf数组里面\static\img\pdfFiles\typesPdf
            if(arList!=null && arList.size()>0){
                for(int m=0;m<arList.size();m++){
                    String str = arList.get(m).getPdfPath();
                    if(StringUtils.isNotBlank(str)){
                        pdfList.add(str);
                    }
                }
                //对所有地址的pdf进行合成
                Jpg2PdfUtil.mulFile2One(response,pdfList,pdfWater);
            }
        }
    }
/*
    @ResponseBody
    @RequestMapping(value = "/getPdfById")
    public String getPdfById(HttpServletResponse response, HttpServletRequest request, @Param("id") String idStr) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        String result = "";
        // 项目在容器中实际发布运行的根路径
        String realPath = request.getSession().getServletContext().getRealPath("/");
        realPath = realPath.split("target")[0] + pictureUrl + "\\static\\img\\";
        //pdf名称
        String pdfFile = String.valueOf(System.currentTimeMillis());
        String pdfPath = realPath + "pdfFiles\\typesPdf\\" + pdfFile + ".pdf";
        Archive_Detail detail=new Archive_Detail();
        detail.setTitle(idStr);
        //根据所有id获取PDF列表
        List<Archive_Detail> arList = archiveDetailService.selectByIdStr(detail);
        //获取废除的pdf文件名列表archive_detail
        List pdfList = new ArrayList();
        //将所有记录的pdf数组里面\static\img\pdfFiles\typesPdf
        if(arList!=null && arList.size()>0){
            for(int m=0;m<arList.size();m++){
                String str = arList.get(m).getPdfPath();
                if(str.indexOf("..\\static\\img\\pdfFiles\\") != -1) {
                    str = str.split("pdfFiles")[1];
                    str = realPath + "pdfFiles" + str;
                }
                pdfList.add(str);
            }
            //对所有地址的pdf进行合成
            PrintToPdfUtil.mergePdfFiles(pdfList, pdfPath);
            result = pdfFile + ".pdf";
        }else{
            result="";
        }
        return result;
    }
*/

    @ResponseBody
    @RequestMapping(value = "/delPdf")
    public String delPdf(HttpServletResponse response, HttpServletRequest request,String pdfName) throws Exception {
        String msg = "";
        // 项目在容器中实际发布运行的根路径
        String realPath = request.getSession().getServletContext().getRealPath("/");
        realPath = realPath.split("target")[0] + pictureUrl+"\\static\\img\\uploads\\";
        realPath=realPath + "pdfFiles\\" + pdfName + ".pdf";
        //将之前文件删除
        File file1 = new File(realPath);
        if (file1.exists() && file1.isFile()) {
            file1.delete();
            msg="删除成功";
        }
        return msg;
    }

    @ResponseBody
    @RequestMapping(value = "/delImg")
    public String delImg(HttpServletResponse response, HttpServletRequest request,Emr_Picture emrPicture) throws Exception {
        request.setCharacterEncoding("utf-8");
        response.setCharacterEncoding("utf-8");
        String msg = "";
        int bol =0;
        if (emrPicture.getId() != null && emrPicture.getId() != "" && emrPicture.getId() != "-1") {
            //判断记录是否存在
            Emr_Picture entity=emrPictureService.selectByid(emrPicture.getId());
            if(entity!=null){
                String realPath = request.getSession().getServletContext().getRealPath("/");
                realPath = realPath.split("target")[0] + pictureUrl;
                String imgPath=entity.getMaxPicture().replace("..",realPath);
                //将之前图片文件删除
                File file1 = new File(imgPath);
                if (file1.exists() && file1.isFile()) {
                    file1.delete();

                    // 设置存放图片文件的路径
                    String path2 = "\\static\\img\\uploads\\";

                    //病案号
                    if (entity.getRelationId() != null && entity.getRelationId() != "") {
                        path2 = path2 + entity.getRelationId() + "\\";
                    }

                    //类型
                    if (entity.getAssortId() != null && entity.getAssortId() != "") {
                        path2 = path2 + entity.getAssortId() + "\\";
                    }
                    String pdfPath= realPath + "\\static\\img\\pdfFiles\\" + entity.getRelationId() + "\\" + entity.getAssortId()+"\\"+ entity.getAssortId() + ".pdf";
                    //将之前文件删除
                    File file = new File(pdfPath);
                    if (file1.exists() && file1.isFile()) {
                        file1.delete();
                    }

                    //重新生成pdf
                    //读取指定路径下的文件名和目录名
                    List arr = new ArrayList();
                    //arr.add(pathType);
                    //图片转PDF(病案号文件夹+类别文件夹)
                    PrintToPdfUtil.toPdf(realPath + path2 , pdfPath , arr);

                }

                //存在删除
                bol = emrPictureService.deleteById(emrPicture.getId());
            }
        }
        if(bol==1) {
            msg = "删除成功!";


        }else{
            msg = "删除失败!";
        }
        return msg;
    }

    /**
     * 图片列表查询
     * @param response
     * @param
     * @param emrPicture
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/getPicList")
    public List<Emr_Picture> getPicList(HttpServletResponse response, Emr_Picture emrPicture) throws Exception {
        List<Emr_Picture> picList = emrPictureService.selectByClo(emrPicture);
        return picList;
    }



    /**
     * 批量图片上传
     *
     * @param resp
     * @param request
     * @param
     * @return
     * @throws IOException
     */
    @ResponseBody
    @RequestMapping(value = "/uploadImgS", method = RequestMethod.POST)
    public String uploadImgS(HttpServletResponse resp, HttpServletRequest request, @RequestParam MultipartFile[] imgs) throws Exception {
        resp.setContentType("text/json");
        resp.setCharacterEncoding("utf-8");
        request.setCharacterEncoding("utf-8");
        String firstFile =request.getParameter("fileName");
        String list = request.getParameter("list");
        String masterID = request.getParameter("masterID");
        int t = 0;
        //String id = request.getParameter("id");
        JSONArray fileObj = JSONArray.fromObject(list);
        String result = "";
        if (!masterID.isEmpty()) {
            String fileName = "";
            String path = null;
            String type = null;
            //type = fileName.indexOf(".") != -1 ? fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length()) : null;
            // 项目在容器中实际发布运行的根路径
            String realPath = request.getSession().getServletContext().getRealPath("/");
            realPath = realPath.split("target")[0] + pictureUrl;

            // 设置存放图片文件的路径
            String path2 = "\\static\\img\\uploads\\";

            //病案号
            if (masterID != null && masterID != "") {
                path2 = path2 + masterID + "\\";
            }

            // 从session获取用户名
            Subject currentUser = SecurityUtils.getSubject();
            Session session = currentUser.getSession();
            String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

            //类循环
            if (fileObj != null && fileObj.size() > 0) {
                for (int x = 0; x < fileObj.size(); x++) {
                    JSONObject obj = fileObj.getJSONObject(x);
                    //类别
                    String pathType = "";
                    if (obj.get("selectVal") != null && obj.get("selectVal") != "") {
                        pathType = obj.get("selectVal") + "\\";

                        //图片id
//                        if (id != null && id != "") {
//                            path2 = path2 + id + "\\";
//                        } else {
//                            path2 = path2 + idTime + "\\";
//                        }

                        //判断文件夹是否存在
                        File fileDic = new File(realPath + path2 + pathType);
                        if (!fileDic.exists() && !fileDic.isDirectory()) {
                            fileDic.mkdirs();
                        }

                        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                        String nowTime = format1.format(new Date());

                        //创建时间id
                        String idTime = String.valueOf(System.currentTimeMillis());
                        String trueFileName ="";

                        //将其路径及文件名类型以及参数保存图片相关信息到分段详细表
                        Emr_Picture entity = new Emr_Picture();
                        entity.setRelationId(masterID);
                        entity.setAssortId(obj.get("selectVal").toString());
                        //entity.setMasterid(masterID);
                        entity.setUpdateTime(nowTime);
                        entity.setUpdater(username);


                        int bol = 0;
                        String id= obj.get("id").toString();
                        if (id != null && id != "" && !id.equals("-1")) {
                            Emr_Picture picList = emrPictureService.selectByid(id);

                           // entity.setTypeFlag(id);
                            //判断记录是否已经存在
                            if (picList!=null) {
                                entity.setId(id);
                                //图片是否有改动有改动则删除之前重新上传
                                //String[] img= picList.getMaxPicture().split("/");

                                if(picList.getAssortId()!=entity.getAssortId() || picList.getRelationId()!=entity.getRelationId() ){


                                    //if(img[img.length-1]!= obj.get("fileSrc")){
                                    //将之前文件删除
//                                    File file1 = new File(realPath + "/static" + picList.getMaxPicture().split("static")[1]);
//                                    if (file1.exists() && file1.isFile()) {
//                                        file1.delete();
//                                    }
                                    //上传图片
                                    //imgs[x].transferTo(new File(realPath + path2 + pathType + trueFileName));
                                    //System.out.println(oldName);picList.getMaxPicture()

                                     if(picList.getMaxPicture().indexOf(path2 + pathType)==-1){

                                        // 移动图片
                                        String startPath= realPath + "/static" + picList.getMaxPicture().split("static")[1];
                                        String endPath= realPath + path2 + pathType;
                                        PrintToPdfUtil.moveTotherFolders(startPath, endPath);
                                        String[] oldName= picList.getMaxPicture().split("\\\\");

                                        //新的图片地址
                                        entity.setMaxPicture(".." + path2 + pathType + oldName[oldName.length - 1]);
                                    }
                                     //被修改的类别重新生成pdf，查询出pdf记录
                                    //根据病案号和类别查询是否存在
                                    Archive_Detail detail = new Archive_Detail();
                                    detail.setMasterid(masterID);
                                    detail.setAssortid(picList.getAssortId());
                                    List<Archive_Detail> detailList = archiveDetailService.selectByColm(detail);

                                    //判断pdf是否存在，将之前文件删除
                                    File file1 = new File(detailList.get(0).getPdfPath().replace("..", realPath));
                                    if (file1.exists() && file1.isFile()) {
                                        file1.delete();
                                    }

                                    //读取指定路径下的文件名和目录名
                                    List arr = new ArrayList();
                                    arr.add(picList.getAssortId());
                                    //图片转PDF(病案号文件夹+类别文件夹)
                                    PrintToPdfUtil.toPdf(realPath + path2 + picList.getAssortId(), detailList.get(0).getPdfPath().replace("..", realPath), arr);
                                    //判断pdf文件大小等于了则删除，并删除pdf记录
                                    File file = new File(detailList.get(0).getPdfPath().replace("..", realPath));
                                    if (file.exists() && file.isFile()) {
                                        System.out.println("文件" + file.getName() + "的大小是：" + file.length());
                                        if(file.length()==0){
                                            String pdfPathVal = "..\\static\\img\\pdfFiles\\"+ detail.getMasterid() +"\\"+  picList.getAssortId() + "\\" + picList.getAssortId() + ".pdf";
                                            detail.setPdfPath(pdfPathVal);
                                            archiveDetailService.deleteByClo(detail);
                                            file.delete();
                                            detail.setPdfPath("");
                                        }
                                    }

                                    //根据id修改记录
                                    bol = emrPictureService.updateCloByIdOrFlay(entity);
                                    //}
                                    if (bol == 1) {
                                        result = "批量上传成功！";
                                    } else {
                                        result = "批量上传失败！";
                                    }
                                }

                            } else {

                                //得到图片名
                                String oldName = imgs[t].getOriginalFilename();// 如apple1.jpg
                                String lasName = oldName.substring(oldName.lastIndexOf(".") + 1);
                                if ("GIF".equals(lasName.toUpperCase()) || "JPEG".equals(lasName.toUpperCase()) || "PNG".equals(lasName.toUpperCase()) || "JPG".equals(lasName.toUpperCase())) {

                                    // 自定义的文件名称String.valueOf(System.currentTimeMillis())
                                    trueFileName = firstFile + idTime + oldName;

                                    //上传图片
                                    imgs[t].transferTo(new File(realPath + path2 + pathType + trueFileName));
                                    entity.setId(idTime);
                                    entity.setCreater(username);
                                    entity.setCreateTime(nowTime);
                                    entity.setEffective(1);
                                    entity.setMaxPicture(".." + path2 + pathType + trueFileName);
                                    //插入记录
                                    bol = emrPictureService.insertSel(entity);

                                }
                                t++;
                            }
                        } else {

                            //得到图片名
                            String oldName = imgs[t].getOriginalFilename();// 如apple1.jpg
                            String lasName= oldName.substring(oldName.lastIndexOf(".") + 1);
                            if ("GIF".equals(lasName.toUpperCase()) || "JPEG".equals(lasName.toUpperCase()) || "PNG".equals(lasName.toUpperCase()) || "JPG".equals(lasName.toUpperCase())) {


                                // 自定义的文件名称String.valueOf(System.currentTimeMillis())
                                trueFileName = firstFile + idTime + oldName;

                                //上传图片
                                imgs[t].transferTo(new File(realPath + path2 + pathType + trueFileName));

                                //新的图片地址
                                entity.setMaxPicture(".." + path2 + pathType + trueFileName);
                                entity.setId(idTime);
                                entity.setCreater(username);
                                entity.setCreateTime(nowTime);
                                entity.setEffective(1);
                                //插入记录
                                bol = emrPictureService.insertSel(entity);
                            }
                            t = t + 1;

                        }

                        if (bol == 1) {
                            //根据类别生成pdf:pathType(String.valueOf(System.currentTimeMillis()) )
                            String pdfFile = pathType.replace("\\", "") + ".pdf";

                            //根据病案号和类别查询是否存在
                             Archive_Detail detail = new Archive_Detail();
                            detail.setMasterid(masterID);
                            detail.setAssortid(pathType.replace("\\",""));
                            detail.setPdfPath("..\\static\\img\\pdfFiles\\" + masterID + "\\"+ pathType.replace("\\", "")+"\\" + pathType.replace("\\", ".pdf"));
                            List<Archive_Detail>  voList=archiveDetailService.selectByColm(detail);

                            //pdf存在则删除记录和文件
                            if(voList.size()<=0){
                                //不存在添加记录和转换pdf

                                detail.setFlag("0");//显示
                                detail.setSource("后台");
                                detail.setSys("emr_medical_record");
                                detail.setUploaddatetime(nowTime);
                                detail.setPdfPath("..\\static\\img\\pdfFiles\\" + masterID + "\\" + pathType + pdfFile);

                                int b = archiveDetailService.insertSel(detail);

                            }


                            //判断pdf是否存在，将之前文件删除
                            File file1 = new File(realPath + "\\static\\img\\pdfFiles\\" + masterID + "\\" + pathType + pdfFile);
                            if (file1.exists() && file1.isFile()) {

                                file1.delete();
                            }

                            //读取指定路径下的文件名和目录名
                            List arr = new ArrayList();
                            arr.add(pathType.replace("\\", ""));
                            //图片转PDF(病案号文件夹+类别文件夹)
                            PrintToPdfUtil.toPdf(realPath + path2 + pathType, realPath + "\\static\\img\\pdfFiles\\" + masterID + "\\" + pathType + pdfFile, arr);


                            result = "批量上传成功！";
                        } else {
                            result = "批量上传失败！";
                        }

                    } else {
                        result = "没有找到相对应的文件！";
                    }



                }
            }
        }

        return result;
    }

    /**
     * 图片上传
     * @param resp
     * @param request
     * @param file

     * @return
     * @throws IOException
     */
    @ResponseBody
    @RequestMapping(value = "/uploadImg", method = RequestMethod.POST)
    public String uploadImg(HttpServletResponse resp, HttpServletRequest request, @RequestParam(value = "file", required = false) MultipartFile file) throws IOException {
        resp.setContentType("text/json");
        resp.setCharacterEncoding("utf-8");
        request.setCharacterEncoding("utf-8");
        String firstFile = request.getParameter("fileName");
        String id = request.getParameter("id");
        String masterID = request.getParameter("masterID");
        String assortID = request.getParameter("assortID");
        String result = "";
        if (!file.isEmpty()) {
            // logger.info("成功获取照片");
            String fileName = file.getOriginalFilename();
            String path = null;
            String type = null;
            type = fileName.indexOf(".") != -1 ? fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length()) : null;
            //logger.info("图片初始名称为：" + fileName + " 类型为：" + type);
            if (type != null) {
                if ("GIF".equals(type.toUpperCase()) || "JPEG".equals(type.toUpperCase())|| "PNG".equals(type.toUpperCase()) || "JPG".equals(type.toUpperCase())) {
                    // 项目在容器中实际发布运行的根路径
                    String realPath = request.getSession().getServletContext().getRealPath("/");
                    realPath = realPath.split("target")[0] + pictureUrl;

                    //创建时间id
                    String idTime = String.valueOf(System.currentTimeMillis());
                    // 自定义的文件名称String.valueOf(System.currentTimeMillis())
                    String trueFileName = firstFile+ idTime + fileName.split(".")[1];
                    // 设置存放图片文件的路径
                    String path2 = "\\static\\img\\uploads\\" ;

                    //病案号
                    if (masterID != null && masterID!="") {
                        path2= path2+masterID + "\\";
                    }
                    //类别
                    if(assortID!=null && assortID != ""){
                        path2= path2+ assortID+"\\";
                    }

                    //图片id
                    if (id != null && id != "") {
                        path2 = path2 + id + "\\";
                    }else{
                        path2 = path2 + idTime + "\\";
                    }
                    
                    //判断文件夹是否存在
                    File fileDic = new File(realPath +path2);
                    if (!fileDic.exists() && !fileDic.isDirectory()){
                        fileDic.mkdirs();
                    }
                    //logger.info("存放图片文件的路径:" + path);
                    path= realPath + path2 + trueFileName;

                    SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    String nowTime = format1.format(new Date());
                    //将其路径及文件名类型以及参数保存图片相关信息到分段详细表
                    Emr_Picture entity = new Emr_Picture();
                    entity.setRelationId(masterID);
                    entity.setAssortId(assortID);
                    entity.setUpdateTime(nowTime);
                    entity.setMaxPicture(".."+ path2 + trueFileName);

                    // 从session获取用户名
                    Subject currentUser = SecurityUtils.getSubject();
                    Session session = currentUser.getSession();
                    String username = (String) session.getAttribute("userSession");//获取前面登录的用户名
                    entity.setUpdater(username);


                    int bol = 0;
                    if (id != null && id != "") {
                        Emr_Picture pic = new Emr_Picture();
                        pic.setTypeFlag(id);
                        List<Emr_Picture> list = emrPictureService.selectByClo(pic);
                        entity.setTypeFlag(id);
                        if(list.size()>0){
                            //将之前文件删除
                            File file1 = new File(realPath + "/static" + list.get(0).getMaxPicture().split("static")[1]);
                            if (file1.exists() && file1.isFile()) {
                                file1.delete();
                            }
                            //根据id修改记录
                            bol = emrPictureService.updateCloByIdOrFlay(entity);
                        }else{
                            entity.setId(idTime);
                            entity.setCreater(username);
                            entity.setCreateTime(nowTime);
                            entity.setEffective(1);
                            //插入记录
                            bol = emrPictureService.insertSel(entity);
                        }
                    } else {
                        entity.setId(idTime);
                        entity.setCreater(username);
                        entity.setCreateTime(nowTime);
                        entity.setEffective(1);
                        //插入记录
                        bol = emrPictureService.insertSel(entity);
                    }

                    if (bol == 1) {
                        //文件成功上传到指定目录下
                        file.transferTo(new File(path));

                        result = entity.getMaxPicture();
                    } else {
                        result = "保存文件信息失败！";
                    }

                } else {
                    result = "文件类型有误,请重新上传！";
                }
            } else {
                result = "文件类型为空！";
            }
        } else {
            result = "没有找到相对应的文件！";
        }
        return result;
    }


    /**
     * Pdf上传
     *
     * @param resp
     * @param request
     * @param file
     * @return
     * @throws IOException
     */
    @RequestMapping(value = "/uploadPdf", method = RequestMethod.POST)
    public String uploadPdf(HttpServletResponse resp, HttpServletRequest request, @RequestParam(value = "file", required = false) MultipartFile file) throws IOException {
        resp.setContentType("text/json");
        resp.setCharacterEncoding("utf-8");
        request.setCharacterEncoding("utf-8");
        String firstFile = request.getParameter("fileName");
        String id = request.getParameter("id");
        String masterID = request.getParameter("masterID");
        String assortID = request.getParameter("assortID");
        String result = "";
        if (!file.isEmpty()) {
            // 成功获取照片原名字
            String fileName = file.getOriginalFilename();
            String path = null;
            String type = null;
            type = fileName.indexOf(".") != -1 ? fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length()) : null;
            //logger.info("图片初始名称为：" + fileName + " 类型为：" + type);
            if (type != null) {
                if ("PDF".equals(type.toUpperCase())) {
                    // 项目在容器中实际发布运行的根路径
                    String realPath = request.getSession().getServletContext().getRealPath("/");
                    realPath = realPath.split("target")[0] + pictureUrl;
                    // 自定义的文件名称String.valueOf(System.currentTimeMillis())
                    String trueFileName = firstFile + fileName;
                    // 设置存放图片文件的路径
                    path = realPath + "\\static\\img\\uploads\\" + trueFileName;

                    SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    String nowTime = format1.format(new Date());
                    //将其路径及文件名类型以及参数保存图片相关信息到分段详细表
                    Archive_Detail entity = new Archive_Detail();
                    entity.setMasterid(masterID);
                    entity.setAssortid(assortID);
                    entity.setUploaddatetime(nowTime);

                    entity.setPdfPath("../static/img/uploads/" + trueFileName);
                    Archive_Detail detail = new Archive_Detail();
                    int bol = 0;
                    if (id != null && id != "") {
                        entity.setId(id);
                        detail = archiveDetailService.selectByid(id);
                        if (detail != null) {

                            //根据id修改记录
                            bol = archiveDetailService.updateCloById(entity);
                        }

                    } else {
                        //插入记录
                        bol = archiveDetailService.insertSel(entity);
                    }

                    if (bol == 1) {
                        //将之前文件删除
                        File file1 = new File(realPath + "/static/uploads/" + detail.getPdfPath().split("/")[3]);
                        if (file1.exists() && file1.isFile()) {
                            file1.delete();
                        }
                        file.transferTo(new File(path));
                        //文件成功上传到指定目录下
                        result = entity.toString();
                    } else {
                        result = "保存文件信息失败！";
                    }

                } else {
                    result = "文件类型有误,请重新上传！";
                }
            } else {
                result = "文件类型为空！";
            }
        } else {
            result = "没有找到相对应的文件！";
        }
        return result;
    }

    /*@RequestMapping("toPdf")
    public String toPdf(String masterId,String imgStr,String name,String idStr,Model model){
        model.addAttribute("masterId",masterId);
        model.addAttribute("imgStr",imgStr);
        model.addAttribute("name",name);
        model.addAttribute("idStr",idStr);
        return "pdf";
    }*/
}
 

