/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/8/8 12:46
 * Description:
 */
package com.emr.controller;

import com.emr.entity.*;
import com.emr.service.Archive_MasterService;
import com.emr.service.CompenSateService;
import com.emr.service.Emr_Fault_DetailService;
import com.emr.service.Emr_Fault_TypeService;
import com.emr.service.ipml.EmrPaperPositionInfoServer;
import com.emr.util.ExportExcelUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.cxf.endpoint.Client;
import org.apache.log4j.Logger;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.session.Session;
import org.apache.shiro.subject.Subject;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

@Controller
@RequestMapping("lastVerify")
public class lastVerifyController {
    private static org.apache.log4j.Logger log = Logger.getLogger("myLog");
    //退回病案给金蝶公司的webService接口地址
    @Value("${RETURNWEBSERVICE}")
    private String RETURNWEBSERVICE;
    //webService qName参数1
    @Value("${RETURNPARM1}")
    private String RETURNPARM1;
    //webService qName参数2
    @Value("${RETURNPARM2}")
    private String RETURNPARM2;
    @Autowired
    private Archive_MasterService archiveMasterService;

    @Autowired
    private Emr_Fault_TypeService emrFaultTypeService;

    @Autowired
    private Emr_Fault_DetailService emrFaultDetailService;

    @Autowired
    private EmrPaperPositionInfoServer paperPositionInfoServer;
    @Autowired
    private CompenSateService compenSateService;
    @RequestMapping(value = "/lastVerifys")
    public String faults() {
        return "lastVerifyDir/lastVerifyList";
    }

    @ResponseBody
    @RequestMapping(value = "/lastVerifyList")
    public OffsetLimitPage lastVerifyList(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit,Integer isSearch) {
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        OffsetLimitPage result = archiveMasterService.selectByLast(archiveMasterVo, offset, limit);
        return result;
    }


    @ResponseBody
    @RequestMapping(value = "/updateCompensate")

    public int updateCompensate(String id,String patientId){
       return compenSateService.updateCompenSate(id,patientId);
    }

    @ResponseBody
    @RequestMapping(value = "/updatePacsCompensate")

    public int updatePacsCompensate(String id,String patientId){
        return compenSateService.updatePacsCompenSate(id,patientId);
    }




    @ResponseBody
    @RequestMapping(value = "/exportExcel")
    public void exportExcel(HttpServletResponse response, Archive_Master_Vo archiveMasterVo,Integer isSearch) throws Exception {
        //判断是否是初始化查询，是初始化查询把开始结束时间置空
        if(isSearch == 0){
            archiveMasterVo.setStartDateTo(null);
            archiveMasterVo.setEndDateTo(null);
        }
        String tableThNames = "住院号,住院次数,名字,性别,身份证,出院科室,出院日期,主管医生,状态";
        String fieldCns = "inpNo,visitId,name,sex,idNo,deptName,dischargeDateTime,doctorInCharge,archivestate";
        //构造excel的数据
        List<Archive_Master_Vo> list = archiveMasterService.selectByLast(archiveMasterVo);

        //文件名
        String fileName = "病案室终审" + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()) + ".xls";
        //ExportExcelUtil
        ExportExcelUtil exportExcelUtil = new ExportExcelUtil();
        response.setContentType("application/ms-excel;charset=gbk");
        //导出excel的操作
        exportExcelUtil.expordExcel(tableThNames, fieldCns, list, fileName, response);
    }


    @ResponseBody
    @RequestMapping(value = "/getFaultType")
    public List<Emr_Fault_Type> getFaultType(HttpServletRequest request, HttpServletResponse response, Emr_Fault_Type emrFaultType) {
        List<Emr_Fault_Type> result = emrFaultTypeService.selectByCol(emrFaultType);
        return result;
    }


    @ResponseBody
    @RequestMapping(value = "/getDetailByArchId")
    public Emr_Fault_Detail getDetailByArchId(HttpServletRequest request, HttpServletResponse response, Emr_Fault_Detail emrFaultDetail) {
        Emr_Fault_Detail result = emrFaultDetailService.selectByArchiveDetailId(emrFaultDetail);
        return result;
    }

    @ResponseBody
    @RequestMapping(value = "/updateDetailByArchivId")
    public int updateDetailByArchivId(Emr_Fault_Detail_Vo emrFaultDetail) {
        //修改病案归档状态：复审退回
        Archive_Master archiveMaster = new Archive_Master();
        archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
        archiveMaster.setArchivestate("复审退回");
        // 从session获取用户名
        Subject currentUser = SecurityUtils.getSubject();
        Session session = currentUser.getSession();
        String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

        //参数输入
        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String nowTime = format1.format(new Date());
        //设置回退给角色信息
        archiveMaster.setReturntoRole(emrFaultDetail.getReturntoRole());
        //设置回退操作人信息
        archiveMaster.setReturnOperUsername(username);
        int bol= 1;
        bol = archiveMasterService.updateByClo(archiveMaster);

        //修改复审内容
        if (bol == 1) {
            emrFaultDetail.setUpdater(username);
            emrFaultDetail.setUpdateTime(nowTime);
            //修改复审内容
            //1、查询出该病案的创建时间最近的缺陷记录
            Emr_Fault_Detail entity= emrFaultDetailService.selectByArchiveDetailId(emrFaultDetail);
            if(null != entity) {
                emrFaultDetail.setId(entity.getId());
                //2、修改缺陷记录
                bol = emrFaultDetailService.updateCloByPrimaryKey(emrFaultDetail);
            }

            //退回金蝶
            //获取基本信息
            Archive_Master archiveMaster1 = archiveMasterService.selectByPrimaryKey(emrFaultDetail.getArchiveDetailId());
            try {
                String msg = "<req>" +
                        "<patNo>" + archiveMaster1.getPatientId() + "</patNo>" +
                        "<patTimes>" + archiveMaster1.getVisitId() + "</patTimes>" +
                        "<patFileNo>" + archiveMaster1.getInpNo() + "</patFileNo>" +
                        "<returnObject>" + emrFaultDetail.getReturntoRole() + "</returnObject>" +
                        "<returnType>01</returnType>" +
                        "<returnName>修改病历</returnName>" +
                        "<returnDept>" + archiveMaster1.getDeptName() + "</returnDept>" +
                        "<regEmp>" + username + "</regEmp>" +
                        "<regDept>8913</regDept>" +
                        "<returnDate>" + nowTime + "</returnDate>" +
                        "<validHours>24</validHours>" +
                        "</req>";
                log.info(msg);
                JAXDynamicClientFactory clientFactory = JAXDynamicClientFactory.newInstance();
                Client client = clientFactory.createClient(RETURNWEBSERVICE);
                QName qname = new QName(RETURNPARM1, RETURNPARM2);
                Object[] result = client.invoke(qname, msg);
                client.destroy();
                Document document = DocumentHelper.parseText(result[0].toString());
                Element rootElement = document.getRootElement();
                Iterator iterator = rootElement.elementIterator();
                while (iterator.hasNext()) {
                    Element element = (Element) iterator.next();
                    if ("resultCode".equals(element.getName())) {
                        System.out.println("resultCode:" + element.getTextTrim());
                    }
                    if ("resultDesc".equals(element.getName())) {
                        System.out.println("resultDesc:" + element.getTextTrim());
                    }
                }
                log.info("回退成功!");
                }catch(Exception e){
                    log.info("回退出错了!");
                    log.info(e.getMessage());
                    e.printStackTrace();
                }
            }
        return bol;
    }

/*
    @ResponseBody
    @RequestMapping(value = "/updateDetailByArchivId")
    public int updateDetailByArchivId(HttpServletRequest request, HttpServletResponse response, Emr_Fault_Detail emrFaultDetail) {

        //修改病案归档状态：复审退回
        Archive_Master archiveMaster = new Archive_Master();
        archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
        archiveMaster.setArchivestate("复审退回");
        int bol = archiveMasterService.updateByClo(archiveMaster);

        //修改复审内容
        if (bol == 1) {
            // 从session获取用户名
            Subject currentUser = SecurityUtils.getSubject();
            Session session = currentUser.getSession();
            String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

            //参数输入
            SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String nowTime = format1.format(new Date());
            emrFaultDetail.setUpdater(username);
            emrFaultDetail.setUpdateTime(nowTime);
            //修改复审内容
            //1、查询出该病案的创建时间最近的缺陷记录
            Emr_Fault_Detail entity= emrFaultDetailService.selectByArchiveDetailId(emrFaultDetail);
            emrFaultDetail.setId(entity.getId());
            //2、修改缺陷记录
            bol = emrFaultDetailService.updateCloByPrimaryKey(emrFaultDetail);
        }
          return bol;
    }
*/
    //终审
    @ResponseBody
    @RequestMapping(value = "/updateStateByArchivId")
    public int updateStateByArchivId(Emr_Fault_Detail_Vo emrFaultDetail,String paperPosition) {
        // 从session获取用户名
        Subject currentUser = SecurityUtils.getSubject();
        Session session = currentUser.getSession();
        String username = (String) session.getAttribute("userSession");//获取前面登录的用户名

        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String nowTime = format1.format(new Date());
        //修改病案归档状态
        Archive_Master archiveMaster = new Archive_Master();
        archiveMaster.setId(emrFaultDetail.getArchiveDetailId());
        archiveMaster.setArchivestate("已归档");
        //设置审核时间
        if(StringUtils.isNotBlank(emrFaultDetail.getCheckedDateTime())){
            nowTime = emrFaultDetail.getCheckedDateTime();
        }
        archiveMaster.setCheckedDatetime(nowTime);
        //设置修改原因
        archiveMaster.setChangeReason(emrFaultDetail.getChangeReason());
        //设置审核人
        archiveMaster.setCheckedDoctor(username);
        int bol = archiveMasterService.updateByClo(archiveMaster);
        //添加初审内容
        if (bol == 1) {
            //参数输入
            emrFaultDetail.setCreater(username);
            emrFaultDetail.setCreateTime(nowTime);
            emrFaultDetail.setState("未召回");
            emrFaultDetailService.insertSel(emrFaultDetail);
        }
        //设置物理位置信息
        if(StringUtils.isNotBlank(paperPosition)){
            paperPositionInfoServer.savePaperPositionInfo(emrFaultDetail.getArchiveDetailId(),paperPosition);
        }
        return 1;
    }

}
 

