/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/19 15:27
 * Description:患者住院信息主索引表
 */
package com.emr.service;

import com.emr.entity.Archive_Master;
import com.emr.entity.Archive_Master_Vo;
import com.emr.entity.OffsetLimitPage;
import com.emr.entity.OracleEntity;

import java.util.List;

public interface Archive_MasterService {
    /**
     * 根据条件查找病案在院列表分页
     * @param archiveMasterVo
     * @return
     */
    OffsetLimitPage selectByCol(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit);

    /**
     * 根据条件查找在院病案列表
     * @param archiveMasterVo
     * @return
     */
    List<Archive_Master_Vo> selectByCol(Archive_Master_Vo archiveMasterVo);

    /**
     * 根据条件查找病案终审列表分页
     *
     * @param archiveMasterVo
     * @return
     */
    List<Archive_Master_Vo> selectByLast(Archive_Master_Vo archiveMasterVo);

    /**
     * 根据条件查找'归档中','复审退回'病案列表
     *
     * @param archiveMasterVo
     * @return
     */
    List<Archive_Master_Vo> selectByColumn(Archive_Master_Vo archiveMasterVo);


    /**
     * 根据条件查找病案未归档列表分页
     *
     * @param archiveMasterVo
     * @return
     */
    List<Archive_Master_Vo> selectByUnfile(Archive_Master_Vo archiveMasterVo);
    /**
     * 根据条件查找病案'归档中','审核退回'列表分页
     *
     * @param archiveMasterVo
     * @return
     */
    OffsetLimitPage selectByColumn(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit);


    /**
     * 根据条件查找未归档列表分页
     *
     * @param archiveMasterVo
     * @return
     */
    OffsetLimitPage selectByUnfile(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit);

    /**
     * 根据条件查找病案终审列表分页
     *
     * @param archiveMasterVo
     * @return
     */
    OffsetLimitPage selectByLast(Archive_Master_Vo archiveMasterVo, Integer offset, Integer limit);


    List<OracleEntity> selectPaperPatiendIdList(String patientIds);

    List<OracleEntity> selectCallBackPatiendIdList(String patientIds);

    /**
     * 根据条件查询记录
     * @param record
     * @return
     */
    int updateByClo(Archive_Master record);

    /**
     * 根据id修改记录
     * @param record
     * @return
     */
    int updateById(Archive_Master record);
    /**
     * 根据id查询记录
     * @param
     * @return
     */
    Archive_Master selectByPrimaryKey(String id);

    void setPaperStatusAndCallbackStatus(List<Archive_Master_Vo> list);

    List<Archive_Master> selectByObject(Archive_Master master);
}