package com.emr.service.ipml;

import com.emr.dao.EmrPaperPositionInfoMapper;
import com.emr.entity.EmrPaperPositionInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Date;

@Service
@Transactional
public class EmrPaperPositionInfoServer {
    @Autowired
    private EmrPaperPositionInfoMapper paperPositionInfoMapper;
    @Autowired
    private StatisticsService statisticsService;
    public void savePaperPositionInfo(String masterId,String paperPosition){
        //查询masterId在该表中是否存在
        EmrPaperPositionInfo emrPaperPositionInfo = paperPositionInfoMapper.selectByMasterId(masterId);
        if(null == emrPaperPositionInfo){
            emrPaperPositionInfo = new EmrPaperPositionInfo();
        }
        String currentUserName = statisticsService.getCurrentUserName();
        emrPaperPositionInfo.setUpdateUserName(currentUserName);
        SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String nowTime = fmt.format(new Date());
        emrPaperPositionInfo.setUpdateTime(nowTime);
        if(emrPaperPositionInfo.getId() == null){
            //不存在新建
            emrPaperPositionInfo.setCreateUserName(currentUserName);
            emrPaperPositionInfo.setCreateTime(nowTime);
            emrPaperPositionInfo.setPaperPosition(paperPosition);
            emrPaperPositionInfo.setMasterId(masterId);
            paperPositionInfoMapper.insertSelective(emrPaperPositionInfo);
        }else{
            //存在则修改
            emrPaperPositionInfo.setPaperPosition(paperPosition);
            paperPositionInfoMapper.updateByPrimaryKey(emrPaperPositionInfo);
        }
    }
}
