package com.emr.service.ipml;

import com.emr.dao.Emr_LogMapper;
import com.emr.entity.Emr_Fault_Vo;
import com.emr.entity.Emr_Log;
import com.emr.entity.Emr_Log_Vo;
import com.emr.entity.OffsetLimitPage;
import com.emr.service.LogService;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class LogServiceImpl implements LogService {
    @Autowired
    private Emr_LogMapper logMapper;
    @Override
    public int insert(Emr_Log log) {
        return logMapper.insert(log);
    }

    @Override
    public int insertSelective(Emr_Log log) {
        return logMapper.insertSelective(log);
    }

    @Override
    public void deleteLogById(Integer logId) {
        logMapper.deleteByPrimaryKey(logId);
    }

    @Override
    public OffsetLimitPage selectByCol(Emr_Log_Vo emr_log_vo, Integer offset, Integer limit) {
        PageHelper.offsetPage(offset, limit);
        List<Emr_Log_Vo> newsInfoList = logMapper.selectByCol(emr_log_vo);
        return new OffsetLimitPage((Page) newsInfoList);
    }

    @Override
    public List<Emr_Log_Vo> selectByCol(Emr_Log_Vo emr_log_vo) {
        return logMapper.selectByCol(emr_log_vo);
    }

    @Override
    public Emr_Log lastBylogTitle(String logTitle) {
        return logMapper.lastBylogTitle(logTitle);
    }


}
