package com.emr.util;



import com.emr.vo.HisCollectInfo;
import com.mchange.v2.c3p0.ComboPooledDataSource;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.CollectionUtils;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Oracle链接数据库对象
 *
 * @author ZL
 *
 *         2017年7月27日
 */
public class OracleConnect {
    private static ComboPooledDataSource dataSourceTest = null;
    public static PreparedStatement pst = null;
    public static ResultSet rs = null;

    /**
     * 构造函数完成数据库的连接和连接对象的生成
     */
    public OracleConnect() {
        try {
            if (dataSourceTest == null) {
                dataSourceTest = new ComboPooledDataSource();
                // 设置连接参数
                dataSourceTest.setJdbcUrl("jdbc:oracle:thin:@192.168.10.6:1521/orc1");
                dataSourceTest.setDriverClass("oracle.jdbc.driver.OracleDriver");
                dataSourceTest.setUser("pacs");
                dataSourceTest.setPassword("pacs");
                /*dataSourceTest.setJdbcUrl("jdbc:oracle:thin:@localhost:1521/ORCL");
                dataSourceTest.setDriverClass("oracle.jdbc.driver.OracleDriver");
                dataSourceTest.setUser("docus");
                dataSourceTest.setPassword("docus702");*/
                dataSourceTest.setInitialPoolSize(3);
                dataSourceTest.setMaxPoolSize(10);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 取得已经构造生成的数据库连接
     *
     * @return 返回数据库连接对象
     */
    public Connection getConnect() {
        try {
            return dataSourceTest.getConnection();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 使用完一定要关闭（释放资源）
     * @param rs          ResultSet
     * @param stat        Statement
     * @param conn        Connection
     * @throws Exception
     */
    public static void CloseConn(ResultSet rs, Statement stat, Connection conn)
            throws Exception {
        if (rs != null) {
            rs.close();
        }
        if (stat != null) {
            stat.close();
        }
        if (conn != null) {
            conn.close();
        }
    }

    /**
     * 查询一条(多条)记录
     *
     * @param arg0  查询的sql语句
     * @return  list
     * @throws Exception
     */
    @SuppressWarnings({ "rawtypes", "unchecked" })
    public static String select(String arg0) throws Exception {
        String str = "";
        Connection conn = new OracleConnect().getConnect();
        pst = conn.prepareStatement(arg0);
        rs = pst.executeQuery();
        List list = new ArrayList();
        if (rs != null) {
            ResultSetMetaData md = rs.getMetaData();
            int columnCount = md.getColumnCount();
            Map rowData = new HashMap();
            while (rs.next()) {
                str = rs.getString(1);
            }
        }
        OracleConnect.CloseConn(rs, pst, conn);
        return str;
    }
    public static List<HisCollectInfo> select1(String arg0) throws Exception {
        Connection conn = new OracleConnect().getConnect();
        pst = conn.prepareStatement(arg0);
        rs = pst.executeQuery();
        List<HisCollectInfo> list = new ArrayList<>();
        if(rs.next()) {
            while (rs.next()) {
                HisCollectInfo info = new HisCollectInfo();
                info.setFpatno(rs.getString(1));
                info.setFentryNo(rs.getString(2));
                info.setFentryName(rs.getString(3));
                info.setFrecName(rs.getString(4));
                info.setFfileId(rs.getString(5));
                info.setPdfflag(rs.getString(6));
                list.add(info);
            }
        }
        OracleConnect.CloseConn(rs, pst, conn);
        return list;
    }
    public static List<String> select2(String arg0) throws Exception {
        Connection conn = new OracleConnect().getConnect();
        pst = conn.prepareStatement(arg0);
        rs = pst.executeQuery();
        List<String> list = new ArrayList<>();
        if(rs.next()) {
            while (rs.next()) {
                list.add(rs.getString(1));
            }
        }
        OracleConnect.CloseConn(rs, pst, conn);
        return list;
    }

    public static Map<String, List<String>> select3(String arg0, List<String> fieldList) throws Exception{
        System.out.println(arg0);
        Connection conn = new OracleConnect().getConnect();
        pst = conn.prepareStatement(arg0);
        rs = pst.executeQuery();
        Map<String, List<String>> map = new HashMap<>();
        ResultSet rs1 = rs;
        if(rs.next()) {
            for (int i = 0;i<fieldList.size();i++){
                List<String> list = new ArrayList<>();
                while (rs1.next()) {
                    String value = rs.getString(i + 1);
                    if(StringUtils.isNotBlank(value)){
                        list.add(value);
                    }
                }
                if(!CollectionUtils.isEmpty(list)) {
                    map.put(fieldList.get(i), list);
                }
            }
        }
        OracleConnect.CloseConn(rs, pst, conn);
        return map;
    }


    public static int insert(String sql) throws Exception {
        Connection conn = new OracleConnect().getConnect();
        try {
            pst=conn.prepareStatement(sql);
            return pst.executeUpdate();
        } catch (SQLException e) {
            e.printStackTrace();
        }finally {
            OracleConnect.CloseConn(null, pst, conn);
        }
        return 1;
    }

}
