/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/9/17 9:26
 * Description:
 */
package com.emr.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfReader;
import org.springframework.beans.factory.annotation.Value;

public class PDFUtils {

    public static void main(String[] args) {
//        File[] pdfs = new File[9];
//        pdfs[0] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\d10db823-7af0-407f-bfb9-cb992a271dac.pdf");
//        pdfs[1] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\dc37ad48-5392-4239-bb07-d39a6d975a4b.pdf");
//        pdfs[2] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\4c981c6e-30a6-45de-a4d2-ec8ffa92b2ab.pdf");
//        pdfs[3] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\52dd7990-2377-4c3a-9b65-8bf0a72b0bfa.pdf");
//        pdfs[4] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\c145b11c-923d-4a4f-a387-2041ae08e4c0.pdf");
//
//        pdfs[5] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\c145b11c-923d-4a4f-a387-2041ae08e4c0.pdf");
//        pdfs[6] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\aaa58453-838f-49b0-8623-72188d7ef634.pdf");
//        pdfs[7] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\0000b5c4-5e91-4252-895c-b92560800064.pdf");
//        pdfs[8] = new File("C:\\Users\\Administrator\\Desktop\\病案pdf\\1422482_1\\1f9babf2-8e61-4659-aafa-7231fe6cbfd8.pdf");
//        File mergedPdf = new File("C:\\Users\\Administrator\\Desktop\\cs2\\MergedDiagram1.pdf");
//        try {
//            merge(pdfs, mergedPdf);
//        } catch (IOException | DocumentException e) {
//            e.printStackTrace();
//        }
        String projectPath = System.getProperty("user.dir") + "\\static\\img\\pdfFiles\\typesPdf\\";
        System.out.println("projectPath==" + projectPath);
        PDFUtils.delAllFile(projectPath);
    }

    //删除指定文件夹下的所有文件
    public static boolean delAllFile(String path) {
        boolean flag = false;
        File file = new File(path);
        if (!file.exists()) {
            return flag;
        }
        if (!file.isDirectory()) {
            return flag;
        }
        String[] tempList = file.list();
        File temp = null;
        for (int i = 0; i < tempList.length; i++) {
            if (path.endsWith(File.separator)) {
                temp = new File(path + tempList[i]);
            } else {
                temp = new File(path + File.separator + tempList[i]);
            }
            if (temp.isFile()) {
                temp.delete();
            }
            if (temp.isDirectory()) {
                delAllFile(path + "/" + tempList[i]);//先删除文件夹里面的文件
                //delFolder(path + "/" + tempList[i]);//再删除空文件夹
                flag = true;
            }
        }
        return flag;
    }

    public static void getPdf(String filePath, List pathArr){
        if(pathArr!=null) {
            File[] pdfs = new File[pathArr.size()];
            for (int i = 0; i < pathArr.size(); i++) {
                pdfs[i] = new File(pathArr.get(i).toString());
            }
            File mergedPdf = new File(filePath);
            try {
                merge(pdfs, mergedPdf);
            } catch (IOException | DocumentException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * @param pages
     * @param pdffile
     * @throws IOException
     * @throws DocumentException
     */
    public static void merge(File[] pages, File pdffile) throws IOException,
            DocumentException {
        if (!pdffile.exists()) {
            pdffile.createNewFile();
        }
        if (pages.length < 1)
            return;

        Document document = new Document(new PdfReader(
                ((File) pages[0]).getAbsolutePath()).getPageSize(1));
        PdfCopy copy = new PdfCopy(document, new FileOutputStream(pdffile));
        document.open();
        for (int i = 0; i < pages.length; i++) {
            PdfReader reader = new PdfReader((pages[i]).getAbsolutePath());
            int num = reader.getNumberOfPages();
            for (int j = 1; j <= num; j++) {
                document.newPage();
                PdfImportedPage page = copy.getImportedPage(reader, j);
                copy.addPage(page);
            }
        }
        copy.close();
        document.close();
//         for (File page : pages) {
//         page.deleteOnExit();
//         }
    }
}
 

