/**
 * Copyright (C), 2015-2019
 * Author:   HJL
 * Date:     2019/7/31 19:49
 * Description:
 */
package com.emr.util;

import com.lowagie.text.Document;
import com.lowagie.text.Image;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.PdfCopy;
import com.lowagie.text.pdf.PdfImportedPage;
import com.lowagie.text.pdf.PdfReader;
import com.lowagie.text.pdf.PdfWriter;
import org.apache.commons.io.FileUtils;
import org.apache.pdfbox.multipdf.PDFMergerUtility;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * 将多张图片合并转为PDF；需要用到iTextpdf包，
 *
 * @author
 */
public class PrintToPdfUtil {

    /**
     * @param imageFolderPath 图片文件夹地址
     * @param pdfPath         PDF文件保存地址
     */
    public static void toPdf(String imageFolderPath, String pdfPath,List dirList) throws IOException {
        // 创建文档
        Document doc = new Document(null, 0, 0, 0, 0);
        FileOutputStream fos = null;
        try {
            //判断文件夹是否存在
            String pdfStr = pdfPath.substring(0, pdfPath.lastIndexOf("\\"));
            File fileDic = new File(pdfStr);
            if (!fileDic.exists() && !fileDic.isDirectory()) {
                fileDic.mkdirs();
            }
            //判断pdf是否存在，将之前文件删除
            File file1 = new File(pdfPath);
            if (file1.exists() && file1.isFile()) {
                if (file1.renameTo(file1)) {
                    System.out.println("文件未被操作");
                } else {
                    System.out.println("文件正在被操作");
                }
                file1.delete();
                System.gc();
            }

            // 输入流
            fos = new FileOutputStream(pdfPath);

            //doc.open();
            // 写入PDF文档
            PdfWriter.getInstance(doc, fos);

            // 获取图片文件夹对象
            File file = new File(imageFolderPath);
            //imageFolderPath = file.getAbsolutePath() + "\\";
           imgFun(imageFolderPath,file, dirList, doc);


        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            if(null != fos){
                fos.flush();
                fos.close();
            }
            if (doc.isOpen()) {
                // 关闭文档
                doc.close();
            }
        }
    }


    public static void imgFun(String imageFolderPath,File file, List dirList, Document doc){
        // 读取图片流
        BufferedImage img = null;
        // 实例化图片
        Image image = null;
        File[] files = file.listFiles();
        if (files.length > 0) {
            // 循环获取图片文件夹内的图片
            try {
                for (File file1 : files) {
                    if (file1.getName().endsWith(".png") || file1.getName().endsWith(".jpg") || file1.getName().endsWith(".gif")
                            || file1.getName().endsWith(".jpeg") || file1.getName().endsWith(".tif")) {

                        imageFolderPath = file1.getAbsolutePath();

                        // 读取图片流
                        img = ImageIO.read(new File(imageFolderPath));
                        //String pdfStr=imageFolderPath.substring(0, imageFolderPath.lastIndexOf("\\")).replace("uploads", "pdfFiles");

                        //判断文件夹是否存在
                        //File fileDic = new File(pdfStr);
                        //if (!fileDic.exists() && !fileDic.isDirectory()) {
                            //fileDic.mkdirs();
                        //}
                        System.out.println("路径" + imageFolderPath);
                        doc.setPageSize(new Rectangle(img.getWidth(), img.getHeight()));
                        // 根据图片大小设置文档大小
                        //doc.setPageSize(new Rectangle(img.getWidth(), img.getHeight()));
                        // 实例化图片
                        image = Image.getInstance(imageFolderPath);
                        // 添加图片到文档
                        doc.open();
                        doc.add(image);
                    }
                    //file.getAbsolutePath().replaceFirst(path, " ");
                    if (file1.isDirectory()) {
                        if (dirList != null && dirList.size() > 0) {
                            if (dirList.indexOf(file1.getName()) != -1) {
                                System.out.println(file1.getAbsolutePath());
                                imageFolderPath = file1.getAbsolutePath() + "\\";
                                imgFun(imageFolderPath, file1, dirList, doc);

                            }
                        } else {
                            System.out.println(file1.getAbsolutePath());
                            imageFolderPath = file1.getAbsolutePath() + "\\";
                            imgFun(imageFolderPath, file1, dirList, doc);
                        }
                    }

                }
            } catch(Exception e){
                e.printStackTrace();
            } finally {
                img.flush();
                if (doc.isOpen()) {
                    // 关闭文档
                    doc.close();
                }
            }
        }else{
            System.out.println("空文件夹");
        }

    }


    public static void pdtToPdf(String pdfFolderPath, String pdfPath, List dirList, List pdfList) {
        try {
            // 输入流
//            FileOutputStream fos = new FileOutputStream(pdfPath);
//            // 创建文档
             Document doc = new Document(null, 0, 0, 0, 0);
//            //doc.open();
//            // 写入PDF文档
//            PdfWriter.getInstance(doc, fos);
//
//            // 获取文件夹对象
            File file = new File(pdfFolderPath);
            PDFMergerUtility mergePdf = new PDFMergerUtility();

            //imageFolderPath = file.getAbsolutePath() + "\\";
            pdfFun(pdfFolderPath, file, dirList, pdfList, mergePdf);
            mergePdf.setDestinationFileName(pdfPath);
            mergePdf.mergeDocuments();
            System.out.print("done");
//            if (doc.isOpen()) {
//                // 关闭文档
//                doc.close();
//            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public static void pdfFun(String pdfFolderPath, File file, List dirList,List pdfList, PDFMergerUtility mergePdf) {
        try {
            File[] files = file.listFiles();
            if(file!=null)
            if (files.length > 0) {
                // 循环获取图片文件夹内的图片
                for (File file1 : files) {
                    if (file1.getName().endsWith(".pdf")) {
                        //System.out.println(file1.length());
                        if (pdfList != null && pdfList.size() > 0) {
                            System.out.println("文件名："+file1.getName());
                            if (pdfList.indexOf(file1.getName()) != -1) {

                            }else{
                                if (file1.length() == 0) {
                                    //file.delete();
                                } else {
                                    pdfFolderPath = file1.getAbsolutePath();
                                    mergePdf.addSource(pdfFolderPath);
                                }
                            }
                        }else{
                            if (file1.length() == 0) {
                                //file.delete();

                            } else {
                                pdfFolderPath = file1.getAbsolutePath();
                                mergePdf.addSource(pdfFolderPath);
                            }
                        }

                    }

                    if (file1.isDirectory()) {
                        if (dirList != null && dirList.size() > 0) {
                            if (dirList.indexOf(file1.getName()) != -1) {
                                pdfFolderPath =  file1.getAbsolutePath() + "\\";
                                pdfFun(pdfFolderPath, file1, dirList, pdfList, mergePdf);

                            }
                        } else {
                            pdfFolderPath = file1.getAbsolutePath() + "\\";
                            pdfFun(pdfFolderPath, file1, dirList, pdfList, mergePdf);
                        }
                    }

                }
            } else {
                System.out.println("空文件夹");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 保存文件
     *
     * @param file          保存的文件
     * @param filename      保存文件的名称（参考）
     * @param savepath      文件保存的路径
     * @return boolean (true:保存成功;false:保存失败)
     */
    public static boolean save(File file, String filename, String savepath) {
        filename = filename;
        File f = new File(savepath, filename);
        try {
            FileUtils.copyFile(file, f);
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    public static void moveTotherFolders(String startPath, String endPath) {
        try {
            File startFile = new File(startPath);
            File tmpFile = new File(endPath);//获取文件夹路径
            if (!tmpFile.exists()) {//判断文件夹是否创建，没有创建则创建新文件夹
                tmpFile.mkdirs();
            }
            System.out.println(endPath + startFile.getName());
            if (startFile.renameTo(new File(endPath + startFile.getName()))) {
                System.out.println("File is moved successful!");
                //log.info("文件移动成功！文件名：《{}》 目标路径：{}", fileName, endPath);
            } else {
                System.out.println("File is failed to move!");
                //log.info("文件移动失败！文件名：《{}》 起始路径：{}", fileName, startPath);
            }
        } catch (Exception e) {
            //log.info("文件移动异常！文件名：《{}》 起始路径：{}", fileName, startPath);

        }
    }


    /*
     * * 合並pdf文件 * * @param files 要合並文件數組(絕對路徑如{ "e:\\1.pdf", "e:\\2.pdf" ,
     * "e:\\3.pdf"}) * @param newfile
     * 合並後新產生的文件絕對路徑如e:\\temp.pdf,請自己刪除用過後不再用的文件請 * @return boolean
     * 產生成功返回true, 否則返回false
     */

    public static boolean mergePdfFiles(List files, String newfile) {
        boolean retValue = false;
        Document document = null;
        PdfCopy copy = null;
        try {
            document = new Document(new PdfReader(files.get(0).toString()).getPageSize(1));
            copy = new PdfCopy(document, new FileOutputStream(newfile));
            document.open();
            for (int i = 0; i < files.size(); i++) {
                PdfReader reader = new PdfReader(files.get(i).toString());
                int n = reader.getNumberOfPages();
                long start = System.currentTimeMillis();
                for (int j = 1; j <= n; j++) {
                    document.newPage();
                    PdfImportedPage page = copy.getImportedPage(reader, j);
                    copy.addPage(page);
                }
                long end = System.currentTimeMillis();
                System.out.println("合成pdf时间");
            }
            retValue = true;
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            copy.close();
            document.close();
        }
        return retValue;
    }

    public static void main(String[] args) {
       // String pdfFile = String.valueOf(System.currentTimeMillis());
        //读取指定路径下的文件名和目录名
        //List list = new ArrayList();
        //list.add("123");

        //图片转PDF(病案号文件夹+类别文件夹)
        //toPdf("C:/Users/Administrator/Desktop/cs/123123/", "C:/Users/Administrator/Desktop/cs/123123/" + pdfFile + ".pdf", list);

        //多个pdf合成一个
        //pdtToPdf("D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp\\static\\img\\pdfFiles\\1333ad3c4d6448c89372835dbad3c364\\", "D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp\\static\\img\\pdfFiles\\typesPdf\\"+ pdfFile+".pdf", list);

        //图片移动
        //moveTotherFolders("D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp\\static\\img\\uploads\\1333ad3c4d6448c89372835dbad3c364\\HC3SL2HENH348M8X619PMCA7GC5R3125\\2019071905226021565006922724小程序界面.png","D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp\\static\\img\\uploads\\1333ad3c4d6448c89372835dbad3c364\\SDV1QEHUPQRQ8GXJE4RQH0FGAS1V7HM0\\");
        //moveTotherFolders("D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp/static\\img\\uploads\\1333ad3c4d6448c89372835dbad3c364\\HC3SL2HENH348M8X619PMCA7GC5R3125\\2019071905226021565064554400fw.jpg", "D:\\project_js\\EMR_Medical_Record\\src\\main\\webapp\\static\\img\\uploads\\1333ad3c4d6448c89372835dbad3c364\\3\\");
        List list = new ArrayList();
        list.add("C:\\Users\\Administrator\\Desktop\\新建文件夹\\ttt.pdf");
        list.add("C:\\Users\\Administrator\\Desktop\\新建文件夹\\ttt.pdf");
        //String[] files = {"C:\\Users\\Administrator\\Desktop\\新建文件夹\\ttt.pdf", "C:\\Users\\Administrator\\Desktop\\新建文件夹\\sss.pdf"};
        String savepath = "C:\\Users\\Administrator\\Desktop\\新建文件夹\\temp.pdf";
        mergePdfFiles(list, savepath);
    }

}

 

