﻿<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<c:set value="${pageContext.request.contextPath}" var="path" scope="page"/>
<html>
<head>
    <title>终审记录明细报表</title>
    <meta charset="utf-8">
    <!-- 解决部分兼容性问题，如果安装了GCF，则使用GCF来渲染页面，如果未安装GCF，则使用最高版本的IE内核进行渲染。 -->
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <!-- 页面按原比例显示 -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <%@include file="../../jspf/comm.jspf" %>
    <style>
        /* .divCss {
             margin-top: 5px;
         }*/
        .divCss8 {
            margin-top: 5px;
            margin-right: 20px;
        }
        /* dataTables表头居中 */
        .table > thead:first-child > tr:first-child > th {
            text-align: center !important;
        }
    </style>
    <script>
        var path = "${path}";
    </script>
</head>

<body>
<!--隐藏是否是初始化-->
<input type="hidden" id="isSearch" value="0">
<div style="margin-left:30px;margin-right:10px;height:auto">
    <!--搜索-->
    <form style="margin-top:20px;">
        <div class="form-inline">
            <div class="form-group divCss8">
                <label>审核日期:</label>
                <div class="input-group">
                    <input type="text" class="input-sm form-control" id="startTime1" style="text-align: center"/>
                    <span class="input-group-addon">-</span>
                    <input type="text" class="input-sm form-control" id="endTime1" style="text-align: center"/>
                </div>
            </div>
            <div class="form-group divCss8">
                <label>审核姓名:</label>
                <input type="text" class="form-control input-sm" id="checkDoctor">
            </div>
            <div class="form-group divCss8">
                <label >出院科室:</label>
                <select class="selectpicker bla bla bli" multiple data-live-search="true" name="deptName"
                        id="deptName"
                        title="请输入出院科室">
                    <option value="">全部</option>
                </select>
            </div>
            <div class="form-group divCss8">
                <label>患者姓名:</label>
                <input type="text" class="form-control input-sm" id="name">
            </div>
            <div class="form-group divCss8">
                <label>住院号:</label>
                <input type="text" class="form-control input-sm" id="inpNo">
            </div>
            <div class="form-group divCss8">
                <label>出院日期:</label>
                <div class="input-group">
                    <input type="text" class="input-sm form-control"  id="startTime2" style="text-align: center"/>
                    <span class="input-group-addon">-</span>
                    <input type="text" class="input-sm form-control"  id="endTime2" style="text-align: center"/>
                </div>
            </div>
            <div class="form-group divCss8">
                <button type="button" class="btn btn-primary btn-sm divCss" id="searchBtn">查询</button>
                <button type="button" class="btn btn-info btn-sm divCss" id="excelBtn">条件导出</button>
            </div>
        </div>
    </form>
    <!--数据表格-->
    <table id="table" class="table text-nowrap table-bordered"></table>
    <div id="toolbar" class="btn-group pull-right" style="margin-right: 20px;">
        <div class="columns columns-right btn-group pull-right">
            <div class="btn-group btn-info">
                <select id="sel_exportoption" class="form-control">                
                    <option value="">导出当前页面数据</option>                                   
                    <option value="all">导出全部数据</option>                                 
                    <option value="selected">导出选中数据</option>
                </select>
            </div>
            <button class=" btn btn-success" style="height: 34px" type="button" id="refreshBtn" name="refresh"
                    aria-label="Refresh"
                    title="Refresh">
                <i class="glyphicon glyphicon-refresh icon-refresh"></i>
            </button>
        </div>
    </div>
</div>
<script src="${path}/static/js/statistics/finalStatisticsDetail.js?t=2020-12-24"></script>
<script src="${path}/static/js/statistics/getDeptCommom.js"></script>
<script src="${path}/static/js/statistics/statisticsCommom.js?t=2020-01-09"></script>
</body>
</html>