<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<c:set value="${pageContext.request.contextPath}" var="path" scope="page"/>
<html>
<head>
    <title>医师归档统计</title>
    <meta charset="utf-8">
    <!-- 解决部分兼容性问题，如果安装了GCF，则使用GCF来渲染页面，如果未安装GCF，则使用最高版本的IE内核进行渲染。 -->
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <!-- 页面按原比例显示 -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <%@include file="../../jspf/comm.jspf" %>
    <style>
        #print{
            width: 100%;
            height: 30px;
            text-align: right;
        }
        #table{
            width: 100%;
            height: auto;
        }
        table{
            border-collapse:collapse;
            border-spacing:0;
            border-left:1px solid #888;
            border-top:1px solid #888;
            background:#fff;
        }
        th,td{
            border-right:1px solid #888;
            border-bottom:1px solid #888;
            padding:5px 15px;
            text-align: center;
        }
        th{
            font-weight:bold;
            background:#fff;
            font-size: 14px;
        }
        td{
            font-size:12px;
            height: 30px;
        }

    </style>
</head>

<body style="height:auto">
<div id="print">
    <button class="btn-primary input-sm" id="printMethod" type="button">打印</button>
</div>
<div><h1 align="center" id="h1"></h1></div>
<div id="table">
    <table id="table1" style="margin-top: 20px;width: 100%">
        <tr>
            <th width='16%' height='30px'>出院科室</th>
            <th width='16%' height='30px'>住院医师</th>
            <th width='16%' height='30px'>求和项:天数</th>
            <th width='16%' height='30px'>求和项:逾期天数</th>
            <th width='16%' height='30px'>计数项:姓名</th>
            <th width='16%' height='30px'>计数项逾期份数</th>
        </tr>
        <%--<tr>
            <td>科室</td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
        </tr>
        <tr>
            <td colspan="2">科室 汇总</td>
            <td></td>
            <td></td>
            <td></td>
            <td></td>
        </tr>--%>
        <c:forEach items="${deptList}" var="dept">
            <c:forEach items="${dept.doctorData}" var="doctor" varStatus="doctorIndex">
                <tr>
                    <c:choose>
                        <c:when test="${doctorIndex.index == 0}">
                            <td>${doctor.deptName}</td>
                        </c:when>
                        <c:otherwise>
                            <td></td>
                        </c:otherwise>
                    </c:choose>
                    <td>${doctor.doctor}</td>
                    <td>${doctor.admissDays}</td>
                    <c:choose>
                        <c:when test="${doctor.overDays != 0}">
                            <td>${doctor.overDays}</td>
                        </c:when>
                        <c:otherwise>
                            <td></td>
                        </c:otherwise>
                    </c:choose>
                    <td>${doctor.recordCount}</td>
                    <c:choose>
                        <c:when test="${doctor.recordOverCount != 0}">
                            <td>${doctor.recordOverCount}</td>
                        </c:when>
                        <c:otherwise>
                            <td></td>
                        </c:otherwise>
                    </c:choose>
                </tr>
            </c:forEach>
            <tr>
                <td colspan="2">${dept.deptName} 汇总</td>
                <td>${dept.deptAdmissDay}</td>
                <td>${dept.deptOverDays}</td>
                <td>${dept.deptCount}</td>
                <td>${dept.deptOverCount}</td>
            </tr>
        </c:forEach>

    </table>
</div>
</body>
<script src="${path}/static/js/vCount/doctorFileListIframe.js?t=2020-01-09"></script>
</html>