jQuery(function ($) {
    //解决模态框背景色越来越深的问题
    $(document).on('show.bs.modal', '.modal', function (event) {
        $(this).appendTo($('body'));
    }).on('shown.bs.modal', '.modal.in', function (event) {
        setModalsAndBackdropsOrder();
    }).on('hidden.bs.modal', '.modal', function (event) {
        setModalsAndBackdropsOrder();
    });

    function setModalsAndBackdropsOrder() {
        var modalZIndex = 1040;
        $('.modal.in').each(function (index) {
            var $modal = $(this);
            modalZIndex++;
            $modal.css('zIndex', modalZIndex);
            $modal.next('.modal-backdrop.in').addClass('hidden').css('zIndex', modalZIndex - 1);
        });
        $('.modal.in:visible:last').focus().next('.modal-backdrop.in').removeClass('hidden');
    }

    //覆盖Modal.prototype的hideModal方法
    $.fn.modal.Constructor.prototype.hideModal = function () {
        var that = this
        this.$element.hide()
        this.backdrop(function () {
            //判断当前页面所有的模态框都已经隐藏了之后body移除.modal-open，即body出现滚动条。
            $('.modal.fade.in').length === 0 && that.$body.removeClass('modal-open')
            that.resetAdjustments()
            that.resetScrollbar()
            that.$element.trigger('hidden.bs.modal')
        })
    }
});
/**
 *格式化列
 */
function paramsMatterColumn(value) {
    if (value != '') {
        return '<p class="hidden-xs-css" title="' + value + '">' + value + '</p>';
    } else {
        return '';
    }
}
//封装改变日期方法
function initDateInput(startTimeId,endTimeId){
    $('#'+startTimeId).datepicker({
        language: "zh-CN",
        format: "yyyy-mm-dd",
        autoclose: true//选中之后自动隐藏日期选择框
    }).on('changeDate',function(){
        $("#beginTime-error").hide();
        var startTime= $("#"+startTimeId).val();
        $("#"+endTimeId).datepicker('setStartDate',startTime);
        $("#"+startTimeId).datepicker('hide');
    });

    $('#'+endTimeId).datepicker({
        language: "zh-CN",
        format: "yyyy-mm-dd",
        autoclose: true//选中之后自动隐藏日期选择框
    }).on('changeDate',function(){
        var startTime = $("#"+startTimeId).val();
        var endtime = $("#"+endTimeId).val();
        $("#"+startTimeId).datepicker('setEndDate',endtime);
        $("#"+endTimeId).datepicker('hide');
    });
}